/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef COPY_GLSL_GEN_HGLES2_120
#define COPY_GLSL_GEN_HGLES2_120


#include "drivers/gles2/shader_gles2.h"


class CopyShaderGLES2 : public ShaderGLES2 {

	 virtual String get_shader_name() const { return "CopyShaderGLES2"; }
public:

	enum Conditionals {
		USE_GLES_OVER_GL,
		USE_DISPLAY_TRANSFORM,
		USE_COPY_SECTION,
		USE_ASYM_PANO,
		USE_CUBEMAP,
		SEP_CBCR_TEXTURE,
		USE_MULTIPLIER,
		USE_CUSTOM_ALPHA,
		USE_PANORAMA,
		YCBCR_TO_RGB,
		USE_NO_ALPHA,
	};

	enum Uniforms {
		COPY_SECTION,
		DISPLAY_TRANSFORM,
		PANO_TRANSFORM,
		ASYM_PROJ,
		MULTIPLIER,
		CUSTOM_ALPHA,
		SKY_TRANSFORM,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	_FORCE_INLINE_ void set_conditional(Conditionals p_conditional,bool p_enable)  {  _set_conditional(p_conditional,p_enable); }

	#ifdef DEBUG_ENABLED
 	#define _FU if (get_uniform(p_uniform)<0) return; if (!is_version_valid()) return; ERR_FAIL_COND( get_active()!=this ); 

 	#else
 	#define _FU if (get_uniform(p_uniform)<0) return; 

 	#endif
	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Size2i& p_vec2) { _FU GLint vec2[2]={p_vec2.x,p_vec2.y}; glUniform2iv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


                glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


        glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
}

#undef _FU


	virtual void init() {

		static const char* _conditional_strings[]={
			"#define USE_GLES_OVER_GL\n",
			"#define USE_DISPLAY_TRANSFORM\n",
			"#define USE_COPY_SECTION\n",
			"#define USE_ASYM_PANO\n",
			"#define USE_CUBEMAP\n",
			"#define SEP_CBCR_TEXTURE\n",
			"#define USE_MULTIPLIER\n",
			"#define USE_CUSTOM_ALPHA\n",
			"#define USE_PANORAMA\n",
			"#define YCBCR_TO_RGB\n",
			"#define USE_NO_ALPHA\n",
		};

		static const char* _uniform_strings[]={
			"copy_section",
			"display_transform",
			"pano_transform",
			"asym_proj",
			"multiplier",
			"custom_alpha",
			"sky_transform",
		};

		static AttributePair _attribute_pairs[]={
			{"vertex_attrib",0},
			{"cube_in",4},
			{"uv_in",4},
			{"uv2_in",5},
		};

		static TexUnitPair _texunit_pairs[]={
			{"source_cube",0},
			{"source",0},
			{"CbCr",1},
		};

		static const char _vertex_code[]={
10,35,105,102,100,101,102,32,85,83,69,95,71,76,69,83,95,79,86,69,82,95,71,76,10,35,100,101,102,105,110,101,32,108,111,119,112,10,35,100,101,102,105,110,101,32,109,101,100,105,117,109,112,10,35,100,101,102,105,110,101,32,104,105,103,104,112,10,35,101,108,115,101,10,112,114,101,99,105,115,105,111,110,32,104,105,103,104,112,32,102,108,111,97,116,59,10,112,114,101,99,105,115,105,111,110,32,104,105,103,104,112,32,105,110,116,59,10,35,101,110,100,105,102,10,10,97,116,116,114,105,98,117,116,101,32,104,105,103,104,112,32,118,101,99,52,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,32,47,47,32,97,116,116,114,105,98,58,48,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,67,85,66,69,77,65,80,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,80,65,78,79,82,65,77,65,41,10,97,116,116,114,105,98,117,116,101,32,118,101,99,51,32,99,117,98,101,95,105,110,59,32,47,47,32,97,116,116,114,105,98,58,52,10,35,101,108,115,101,10,97,116,116,114,105,98,117,116,101,32,118,101,99,50,32,117,118,95,105,110,59,32,47,47,32,97,116,116,114,105,98,58,52,10,35,101,110,100,105,102,10,10,97,116,116,114,105,98,117,116,101,32,118,101,99,50,32,117,118,50,95,105,110,59,32,47,47,32,97,116,116,114,105,98,58,53,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,67,85,66,69,77,65,80,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,80,65,78,79,82,65,77,65,41,10,118,97,114,121,105,110,103,32,118,101,99,51,32,99,117,98,101,95,105,110,116,101,114,112,59,10,35,101,108,115,101,10,118,97,114,121,105,110,103,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,35,101,110,100,105,102,10,118,97,114,121,105,110,103,32,118,101,99,50,32,117,118,50,95,105,110,116,101,114,112,59,10,10,47,47,32,84,104,101,115,101,32,100,101,102,105,110,105,116,105,111,110,115,32,97,114,101,32,104,101,114,101,32,98,101,99,97,117,115,101,32,116,104,101,32,115,104,97,100,101,114,45,119,114,97,112,112,101,114,32,98,117,105,108,100,101,114,32,100,111,101,115,10,47,47,32,110,111,116,32,117,110,100,101,114,115,116,97,110,100,32,96,35,101,108,105,102,32,100,101,102,105,110,101,100,40,41,96,10,35,105,102,100,101,102,32,85,83,69,95,68,73,83,80,76,65,89,95,84,82,65,78,83,70,79,82,77,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,79,80,89,95,83,69,67,84,73,79,78,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,118,101,99,52,32,99,111,112,121,95,115,101,99,116,105,111,110,59,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,68,73,83,80,76,65,89,95,84,82,65,78,83,70,79,82,77,41,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,100,105,115,112,108,97,121,95,116,114,97,110,115,102,111,114,109,59,10,35,101,110,100,105,102,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,67,85,66,69,77,65,80,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,80,65,78,79,82,65,77,65,41,10,9,99,117,98,101,95,105,110,116,101,114,112,32,61,32,99,117,98,101,95,105,110,59,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,65,83,89,77,95,80,65,78,79,41,10,9,117,118,95,105,110,116,101,114,112,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,46,120,121,59,10,35,101,108,115,101,10,9,117,118,95,105,110,116,101,114,112,32,61,32,117,118,95,105,110,59,10,35,101,110,100,105,102,10,10,9,117,118,50,95,105,110,116,101,114,112,32,61,32,117,118,50,95,105,110,59,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,10,35,105,102,100,101,102,32,85,83,69,95,67,79,80,89,95,83,69,67,84,73,79,78,10,9,117,118,95,105,110,116,101,114,112,32,61,32,99,111,112,121,95,115,101,99,116,105,111,110,46,120,121,32,43,32,117,118,95,105,110,116,101,114,112,32,42,32,99,111,112,121,95,115,101,99,116,105,111,110,46,122,119,59,10,9,103,108,95,80,111,115,105,116,105,111,110,46,120,121,32,61,32,40,99,111,112,121,95,115,101,99,116,105,111,110,46,120,121,32,43,32,40,103,108,95,80,111,115,105,116,105,111,110,46,120,121,32,42,32,48,46,53,32,43,32,48,46,53,41,32,42,32,99,111,112,121,95,115,101,99,116,105,111,110,46,122,119,41,32,42,32,50,46,48,32,45,32,49,46,48,59,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,68,73,83,80,76,65,89,95,84,82,65,78,83,70,79,82,77,41,10,9,117,118,95,105,110,116,101,114,112,32,61,32,40,100,105,115,112,108,97,121,95,116,114,97,110,115,102,111,114,109,32,42,32,118,101,99,52,40,117,118,95,105,110,44,32,49,46,48,44,32,49,46,48,41,41,46,120,121,59,10,35,101,110,100,105,102,10,125,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,		0};

		static const int _vertex_code_start=2;
		static const char _fragment_code[]={
10,35,100,101,102,105,110,101,32,77,95,80,73,32,51,46,49,52,49,53,57,50,54,53,51,53,57,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,69,83,95,79,86,69,82,95,71,76,10,35,100,101,102,105,110,101,32,108,111,119,112,10,35,100,101,102,105,110,101,32,109,101,100,105,117,109,112,10,35,100,101,102,105,110,101,32,104,105,103,104,112,10,35,101,108,115,101,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,72,73,71,72,80,95,80,82,69,67,73,83,73,79,78,41,10,112,114,101,99,105,115,105,111,110,32,104,105,103,104,112,32,102,108,111,97,116,59,10,112,114,101,99,105,115,105,111,110,32,104,105,103,104,112,32,105,110,116,59,10,35,101,108,115,101,10,112,114,101,99,105,115,105,111,110,32,109,101,100,105,117,109,112,32,102,108,111,97,116,59,10,112,114,101,99,105,115,105,111,110,32,109,101,100,105,117,109,112,32,105,110,116,59,10,35,101,110,100,105,102,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,67,85,66,69,77,65,80,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,80,65,78,79,82,65,77,65,41,10,118,97,114,121,105,110,103,32,118,101,99,51,32,99,117,98,101,95,105,110,116,101,114,112,59,10,35,101,108,115,101,10,118,97,114,121,105,110,103,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,35,101,110,100,105,102,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,105,102,100,101,102,32,85,83,69,95,65,83,89,77,95,80,65,78,79,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,112,97,110,111,95,116,114,97,110,115,102,111,114,109,59,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,118,101,99,52,32,97,115,121,109,95,112,114,111,106,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,85,66,69,77,65,80,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,67,117,98,101,32,115,111,117,114,99,101,95,99,117,98,101,59,32,47,47,32,116,101,120,117,110,105,116,58,48,10,35,101,108,115,101,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,59,32,47,47,32,116,101,120,117,110,105,116,58,48,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,69,80,95,67,66,67,82,95,84,69,88,84,85,82,69,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,67,98,67,114,59,32,47,47,116,101,120,117,110,105,116,58,49,10,35,101,110,100,105,102,10,10,118,97,114,121,105,110,103,32,118,101,99,50,32,117,118,50,95,105,110,116,101,114,112,59,10,10,35,105,102,100,101,102,32,85,83,69,95,77,85,76,84,73,80,76,73,69,82,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,109,117,108,116,105,112,108,105,101,114,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,85,83,84,79,77,95,65,76,80,72,65,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,117,115,116,111,109,95,97,108,112,104,97,59,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,80,65,78,79,82,65,77,65,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,65,83,89,77,95,80,65,78,79,41,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,115,107,121,95,116,114,97,110,115,102,111,114,109,59,10,10,118,101,99,52,32,116,101,120,116,117,114,101,80,97,110,111,114,97,109,97,40,115,97,109,112,108,101,114,50,68,32,112,97,110,111,44,32,118,101,99,51,32,110,111,114,109,97,108,41,32,123,10,10,9,118,101,99,50,32,115,116,32,61,32,118,101,99,50,40,10,9,9,9,97,116,97,110,40,110,111,114,109,97,108,46,120,44,32,110,111,114,109,97,108,46,122,41,44,10,9,9,9,97,99,111,115,40,110,111,114,109,97,108,46,121,41,41,59,10,10,9,105,102,32,40,115,116,46,120,32,60,32,48,46,48,41,10,9,9,115,116,46,120,32,43,61,32,77,95,80,73,32,42,32,50,46,48,59,10,10,9,115,116,32,47,61,32,118,101,99,50,40,77,95,80,73,32,42,32,50,46,48,44,32,77,95,80,73,41,59,10,10,9,114,101,116,117,114,110,32,116,101,120,116,117,114,101,50,68,40,112,97,110,111,44,32,115,116,41,59,10,125,10,10,35,101,110,100,105,102,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,35,105,102,100,101,102,32,85,83,69,95,80,65,78,79,82,65,77,65,10,10,9,118,101,99,51,32,99,117,98,101,95,110,111,114,109,97,108,32,61,32,110,111,114,109,97,108,105,122,101,40,99,117,98,101,95,105,110,116,101,114,112,41,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,122,32,61,32,45,99,117,98,101,95,110,111,114,109,97,108,46,122,59,10,9,99,117,98,101,95,110,111,114,109,97,108,32,61,32,109,97,116,51,40,115,107,121,95,116,114,97,110,115,102,111,114,109,41,32,42,32,99,117,98,101,95,110,111,114,109,97,108,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,122,32,61,32,45,99,117,98,101,95,110,111,114,109,97,108,46,122,59,10,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,80,97,110,111,114,97,109,97,40,115,111,117,114,99,101,44,32,99,117,98,101,95,110,111,114,109,97,108,41,59,10,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,65,83,89,77,95,80,65,78,79,41,10,10,9,47,47,32,87,104,101,110,32,97,110,32,97,115,121,109,109,101,116,114,105,99,97,108,32,112,114,111,106,101,99,116,105,111,110,32,109,97,116,114,105,120,32,105,115,32,117,115,101,100,32,40,97,112,112,108,105,99,97,98,108,101,32,102,111,114,32,115,116,101,114,101,111,115,99,111,112,105,99,32,114,101,110,100,101,114,105,110,103,32,105,46,101,46,32,86,82,41,32,119,101,32,110,101,101,100,32,116,111,32,100,111,32,116,104,105,115,32,99,97,108,99,117,108,97,116,105,111,110,32,112,101,114,32,102,114,97,103,109,101,110,116,32,116,111,32,103,101,116,32,97,32,112,101,114,115,112,101,99,116,105,118,101,32,99,111,114,114,101,99,116,32,114,101,115,117,108,116,46,10,9,47,47,32,65,115,121,109,109,101,116,114,105,99,97,108,32,112,114,111,106,101,99,116,105,111,110,32,109,101,97,110,115,32,116,104,101,32,99,101,110,116,101,114,32,111,102,32,112,114,111,106,101,99,116,105,111,110,32,105,115,32,110,111,32,108,111,110,103,101,114,32,105,110,32,116,104,101,32,99,101,110,116,101,114,32,111,102,32,116,104,101,32,115,99,114,101,101,110,32,98,117,116,32,115,104,105,102,116,101,100,46,10,9,47,47,32,84,104,101,32,77,97,116,114,105,120,91,50,93,91,48,93,32,40,61,32,97,115,121,109,95,112,114,111,106,46,120,41,32,97,110,100,32,77,97,116,114,105,120,91,50,93,91,49,93,32,40,61,32,97,115,121,109,95,112,114,111,106,46,122,41,32,118,97,108,117,101,115,32,97,114,101,32,119,104,97,116,32,112,114,111,118,105,100,101,32,116,104,101,32,114,105,103,104,116,32,115,104,105,102,116,32,105,110,32,116,104,101,32,105,109,97,103,101,46,10,10,9,118,101,99,51,32,99,117,98,101,95,110,111,114,109,97,108,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,122,32,61,32,45,49,46,48,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,120,32,61,32,40,99,117,98,101,95,110,111,114,109,97,108,46,122,32,42,32,40,45,117,118,95,105,110,116,101,114,112,46,120,32,45,32,97,115,121,109,95,112,114,111,106,46,120,41,41,32,47,32,97,115,121,109,95,112,114,111,106,46,121,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,121,32,61,32,40,99,117,98,101,95,110,111,114,109,97,108,46,122,32,42,32,40,45,117,118,95,105,110,116,101,114,112,46,121,32,45,32,97,115,121,109,95,112,114,111,106,46,122,41,41,32,47,32,97,115,121,109,95,112,114,111,106,46,97,59,10,9,99,117,98,101,95,110,111,114,109,97,108,32,61,32,109,97,116,51,40,115,107,121,95,116,114,97,110,115,102,111,114,109,41,32,42,32,109,97,116,51,40,112,97,110,111,95,116,114,97,110,115,102,111,114,109,41,32,42,32,99,117,98,101,95,110,111,114,109,97,108,59,10,9,99,117,98,101,95,110,111,114,109,97,108,46,122,32,61,32,45,99,117,98,101,95,110,111,114,109,97,108,46,122,59,10,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,80,97,110,111,114,97,109,97,40,115,111,117,114,99,101,44,32,110,111,114,109,97,108,105,122,101,40,99,117,98,101,95,110,111,114,109,97,108,46,120,121,122,41,41,59,10,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,67,85,66,69,77,65,80,41,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,67,117,98,101,40,115,111,117,114,99,101,95,99,117,98,101,44,32,110,111,114,109,97,108,105,122,101,40,99,117,98,101,95,105,110,116,101,114,112,41,41,59,10,35,101,108,105,102,32,100,101,102,105,110,101,100,40,83,69,80,95,67,66,67,82,95,84,69,88,84,85,82,69,41,10,9,118,101,99,52,32,99,111,108,111,114,59,10,9,99,111,108,111,114,46,114,32,61,32,116,101,120,116,117,114,101,50,68,40,115,111,117,114,99,101,44,32,117,118,95,105,110,116,101,114,112,41,46,114,59,10,9,99,111,108,111,114,46,103,98,32,61,32,116,101,120,116,117,114,101,50,68,40,67,98,67,114,44,32,117,118,95,105,110,116,101,114,112,41,46,114,103,32,45,32,118,101,99,50,40,48,46,53,44,32,48,46,53,41,59,10,9,99,111,108,111,114,46,97,32,61,32,49,46,48,59,10,35,101,108,115,101,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,50,68,40,115,111,117,114,99,101,44,32,117,118,95,105,110,116,101,114,112,41,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,89,67,66,67,82,95,84,79,95,82,71,66,10,9,47,47,32,89,67,98,67,114,32,45,62,32,82,71,66,32,99,111,110,118,101,114,115,105,111,110,10,10,9,47,47,32,85,115,105,110,103,32,66,84,46,54,48,49,44,32,119,104,105,99,104,32,105,115,32,116,104,101,32,115,116,97,110,100,97,114,100,32,102,111,114,32,83,68,84,86,32,105,115,32,112,114,111,118,105,100,101,100,32,97,115,32,97,32,114,101,102,101,114,101,110,99,101,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,97,116,51,40,10,9,9,9,9,9,9,118,101,99,51,40,49,46,48,48,48,48,48,44,32,49,46,48,48,48,48,48,44,32,49,46,48,48,48,48,48,41,44,10,9,9,9,9,9,9,118,101,99,51,40,48,46,48,48,48,48,48,44,32,45,48,46,51,52,52,49,51,44,32,49,46,55,55,50,48,48,41,44,10,9,9,9,9,9,9,118,101,99,51,40,49,46,52,48,50,48,48,44,32,45,48,46,55,49,52,49,52,44,32,48,46,48,48,48,48,48,41,41,32,42,10,9,9,9,9,99,111,108,111,114,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,78,79,95,65,76,80,72,65,10,9,99,111,108,111,114,46,97,32,61,32,49,46,48,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,85,83,84,79,77,95,65,76,80,72,65,10,9,99,111,108,111,114,46,97,32,61,32,99,117,115,116,111,109,95,97,108,112,104,97,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,77,85,76,84,73,80,76,73,69,82,10,9,99,111,108,111,114,46,114,103,98,32,42,61,32,109,117,108,116,105,112,108,105,101,114,59,10,35,101,110,100,105,102,10,10,9,103,108,95,70,114,97,103,67,111,108,111,114,32,61,32,99,111,108,111,114,59,10,125,10,		0};

		static const int _fragment_code_start=64;
		setup(_conditional_strings,11,_uniform_strings,7,_attribute_pairs,4, _texunit_pairs,3,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	}

};

#endif

