/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef CANVAS_GLSL_GEN_HGLES3_120
#define CANVAS_GLSL_GEN_HGLES3_120


#include "drivers/gles3/shader_gles3.h"


class CanvasShaderGLES3 : public ShaderGLES3 {

	 virtual String get_shader_name() const { return "CanvasShaderGLES3"; }
public:

	enum Conditionals {
		USE_SKELETON,
		USE_TEXTURE_RECT,
		USE_INSTANCING,
		USE_INSTANCE_CUSTOM,
		MODULATE_USED,
		USE_NINEPATCH,
		USE_LIGHTING,
		USE_SHADOWS,
		USE_PARTICLES,
		USE_PIXEL_SNAP,
		USE_DISTANCE_FIELD,
		DEBUG_ENCODED_32,
		SHADOW_VEC_USED,
		USE_RGBA_SHADOWS,
		SHADOW_USE_GRADIENT,
		SHADOW_FILTER_NEAREST,
		SHADOW_FILTER_PCF3,
		SHADOW_FILTER_PCF5,
		SHADOW_FILTER_PCF7,
		SHADOW_FILTER_PCF9,
		SHADOW_FILTER_PCF13,
	};

	enum Uniforms {
		DST_RECT,
		SRC_RECT,
		COLOR_TEXPIXEL_SIZE,
		MODELVIEW_MATRIX,
		EXTRA_MATRIX,
		FINAL_MODULATE,
		SKELETON_TRANSFORM,
		SKELETON_TRANSFORM_INVERSE,
		SCREEN_PIXEL_SIZE,
		CLIP_RECT_UV,
		NP_REPEAT_V,
		NP_REPEAT_H,
		NP_DRAW_CENTER,
		NP_MARGINS,
		USE_DEFAULT_NORMAL,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	_FORCE_INLINE_ void set_conditional(Conditionals p_conditional,bool p_enable)  {  _set_conditional(p_conditional,p_enable); }

	#ifdef DEBUG_ENABLED
 	#define _FU if (get_uniform(p_uniform)<0) return; if (!is_version_valid()) return; ERR_FAIL_COND( get_active()!=this ); 

 	#else
 	#define _FU if (get_uniform(p_uniform)<0) return; 

 	#endif
	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Size2i& p_vec2) { _FU GLint vec2[2]={p_vec2.x,p_vec2.y}; glUniform2iv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


                glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


        glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
}

#undef _FU


	virtual void init() {

		static const char* _conditional_strings[]={
			"#define USE_SKELETON\n",
			"#define USE_TEXTURE_RECT\n",
			"#define USE_INSTANCING\n",
			"#define USE_INSTANCE_CUSTOM\n",
			"#define MODULATE_USED\n",
			"#define USE_NINEPATCH\n",
			"#define USE_LIGHTING\n",
			"#define USE_SHADOWS\n",
			"#define USE_PARTICLES\n",
			"#define USE_PIXEL_SNAP\n",
			"#define USE_DISTANCE_FIELD\n",
			"#define DEBUG_ENCODED_32\n",
			"#define SHADOW_VEC_USED\n",
			"#define USE_RGBA_SHADOWS\n",
			"#define SHADOW_USE_GRADIENT\n",
			"#define SHADOW_FILTER_NEAREST\n",
			"#define SHADOW_FILTER_PCF3\n",
			"#define SHADOW_FILTER_PCF5\n",
			"#define SHADOW_FILTER_PCF7\n",
			"#define SHADOW_FILTER_PCF9\n",
			"#define SHADOW_FILTER_PCF13\n",
		};

		static const char* _uniform_strings[]={
			"dst_rect",
			"src_rect",
			"color_texpixel_size",
			"modelview_matrix",
			"extra_matrix",
			"final_modulate",
			"skeleton_transform",
			"skeleton_transform_inverse",
			"screen_pixel_size",
			"clip_rect_uv",
			"np_repeat_v",
			"np_repeat_h",
			"np_draw_center",
			"np_margins",
			"use_default_normal",
		};

		static AttributePair *_attribute_pairs=NULL;
		static const Feedback* _feedbacks=NULL;
		static TexUnitPair _texunit_pairs[]={
			{"skeleton_texture",-4},
			{"color_texture",0},
			{"normal_texture",1},
			{"screen_texture",-3},
			{"light_texture",-1},
			{"shadow_texture",-2},
		};

		static UBOPair _ubo_pairs[]={
			{"CanvasItemData",0},
			{"LightData",1},
			{"UniformData",2},
		};

		static const char _vertex_code[]={
10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,50,32,118,101,114,116,101,120,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,51,41,32,105,110,32,118,101,99,52,32,99,111,108,111,114,95,97,116,116,114,105,98,59,10,10,35,105,102,100,101,102,32,85,83,69,95,83,75,69,76,69,84,79,78,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,54,41,32,105,110,32,117,118,101,99,52,32,98,111,110,101,95,105,110,100,105,99,101,115,59,32,47,47,32,97,116,116,114,105,98,58,54,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,55,41,32,105,110,32,118,101,99,52,32,98,111,110,101,95,119,101,105,103,104,116,115,59,32,47,47,32,97,116,116,114,105,98,58,55,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,84,69,88,84,85,82,69,95,82,69,67,84,10,10,117,110,105,102,111,114,109,32,118,101,99,52,32,100,115,116,95,114,101,99,116,59,10,117,110,105,102,111,114,109,32,118,101,99,52,32,115,114,99,95,114,101,99,116,59,10,10,35,101,108,115,101,10,10,35,105,102,100,101,102,32,85,83,69,95,73,78,83,84,65,78,67,73,78,71,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,56,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,105,110,115,116,97,110,99,101,95,120,102,111,114,109,48,59,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,57,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,105,110,115,116,97,110,99,101,95,120,102,111,114,109,49,59,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,49,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,105,110,115,116,97,110,99,101,95,120,102,111,114,109,50,59,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,49,49,41,32,105,110,32,108,111,119,112,32,118,101,99,52,32,105,110,115,116,97,110,99,101,95,99,111,108,111,114,59,10,10,35,105,102,100,101,102,32,85,83,69,95,73,78,83,84,65,78,67,69,95,67,85,83,84,79,77,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,49,50,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,105,110,115,116,97,110,99,101,95,99,117,115,116,111,109,95,100,97,116,97,59,10,35,101,110,100,105,102,10,10,35,101,110,100,105,102,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,52,41,32,105,110,32,104,105,103,104,112,32,118,101,99,50,32,117,118,95,97,116,116,114,105,98,59,10,10,47,47,32,115,107,101,108,101,116,111,110,10,35,101,110,100,105,102,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,118,101,99,50,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,59,10,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,67,97,110,118,97,115,73,116,101,109,68,97,116,97,32,123,32,47,47,117,98,111,58,48,10,10,9,104,105,103,104,112,32,109,97,116,52,32,112,114,111,106,101,99,116,105,111,110,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,116,105,109,101,59,10,125,59,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,109,111,100,101,108,118,105,101,119,95,109,97,116,114,105,120,59,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,101,120,116,114,97,95,109,97,116,114,105,120,59,10,10,111,117,116,32,104,105,103,104,112,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,111,117,116,32,109,101,100,105,117,109,112,32,118,101,99,52,32,99,111,108,111,114,95,105,110,116,101,114,112,59,10,35,105,102,100,101,102,32,77,79,68,85,76,65,84,69,95,85,83,69,68,10,117,110,105,102,111,114,109,32,109,101,100,105,117,109,112,32,118,101,99,52,32,102,105,110,97,108,95,109,111,100,117,108,97,116,101,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,78,73,78,69,80,65,84,67,72,10,10,111,117,116,32,104,105,103,104,112,32,118,101,99,50,32,112,105,120,101,108,95,115,105,122,101,95,105,110,116,101,114,112,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,83,75,69,76,69,84,79,78,10,117,110,105,102,111,114,109,32,109,101,100,105,117,109,112,32,115,97,109,112,108,101,114,50,68,32,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,45,52,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,115,107,101,108,101,116,111,110,95,116,114,97,110,115,102,111,114,109,59,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,109,97,116,52,32,115,107,101,108,101,116,111,110,95,116,114,97,110,115,102,111,114,109,95,105,110,118,101,114,115,101,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,76,73,71,72,84,73,78,71,10,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,76,105,103,104,116,68,97,116,97,32,123,32,47,47,117,98,111,58,49,10,10,9,47,47,32,108,105,103,104,116,32,109,97,116,114,105,99,101,115,10,9,104,105,103,104,112,32,109,97,116,52,32,108,105,103,104,116,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,109,97,116,52,32,108,105,103,104,116,95,108,111,99,97,108,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,109,97,116,52,32,115,104,97,100,111,119,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,118,101,99,52,32,108,105,103,104,116,95,99,111,108,111,114,59,10,9,104,105,103,104,112,32,118,101,99,52,32,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,59,10,9,104,105,103,104,112,32,118,101,99,50,32,108,105,103,104,116,95,112,111,115,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,95,103,114,97,100,105,101,110,116,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,108,105,103,104,116,95,104,101,105,103,104,116,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,108,105,103,104,116,95,111,117,116,115,105,100,101,95,97,108,112,104,97,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,95,100,105,115,116,97,110,99,101,95,109,117,108,116,59,10,125,59,10,10,111,117,116,32,118,101,99,52,32,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,59,10,111,117,116,32,118,101,99,50,32,116,114,97,110,115,102,111,114,109,101,100,95,108,105,103,104,116,95,117,118,59,10,10,111,117,116,32,118,101,99,52,32,108,111,99,97,108,95,114,111,116,59,10,10,35,105,102,100,101,102,32,85,83,69,95,83,72,65,68,79,87,83,10,111,117,116,32,104,105,103,104,112,32,118,101,99,50,32,112,111,115,59,10,35,101,110,100,105,102,10,10,99,111,110,115,116,32,98,111,111,108,32,97,116,95,108,105,103,104,116,95,112,97,115,115,32,61,32,116,114,117,101,59,10,35,101,108,115,101,10,99,111,110,115,116,32,98,111,111,108,32,97,116,95,108,105,103,104,116,95,112,97,115,115,32,61,32,102,97,108,115,101,59,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,77,65,84,69,82,73,65,76,41,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,85,110,105,102,111,114,109,68,97,116,97,32,123,32,47,47,117,98,111,58,50,10,10,77,65,84,69,82,73,65,76,95,85,78,73,70,79,82,77,83,10,10,125,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,101,110,100,105,102,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,10,86,69,82,84,69,88,95,83,72,65,68,69,82,95,71,76,79,66,65,76,83,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,99,111,108,111,114,95,97,116,116,114,105,98,59,10,10,35,105,102,100,101,102,32,85,83,69,95,73,78,83,84,65,78,67,73,78,71,10,9,109,97,116,52,32,101,120,116,114,97,95,109,97,116,114,105,120,95,105,110,115,116,97,110,99,101,32,61,32,101,120,116,114,97,95,109,97,116,114,105,120,32,42,32,116,114,97,110,115,112,111,115,101,40,109,97,116,52,40,105,110,115,116,97,110,99,101,95,120,102,111,114,109,48,44,32,105,110,115,116,97,110,99,101,95,120,102,111,114,109,49,44,32,105,110,115,116,97,110,99,101,95,120,102,111,114,109,50,44,32,118,101,99,52,40,48,46,48,44,32,48,46,48,44,32,48,46,48,44,32,49,46,48,41,41,41,59,10,9,99,111,108,111,114,32,42,61,32,105,110,115,116,97,110,99,101,95,99,111,108,111,114,59,10,10,35,105,102,100,101,102,32,85,83,69,95,73,78,83,84,65,78,67,69,95,67,85,83,84,79,77,10,9,118,101,99,52,32,105,110,115,116,97,110,99,101,95,99,117,115,116,111,109,32,61,32,105,110,115,116,97,110,99,101,95,99,117,115,116,111,109,95,100,97,116,97,59,10,35,101,108,115,101,10,9,118,101,99,52,32,105,110,115,116,97,110,99,101,95,99,117,115,116,111,109,32,61,32,118,101,99,52,40,48,46,48,41,59,10,35,101,110,100,105,102,10,10,35,101,108,115,101,10,9,109,97,116,52,32,101,120,116,114,97,95,109,97,116,114,105,120,95,105,110,115,116,97,110,99,101,32,61,32,101,120,116,114,97,95,109,97,116,114,105,120,59,10,9,118,101,99,52,32,105,110,115,116,97,110,99,101,95,99,117,115,116,111,109,32,61,32,118,101,99,52,40,48,46,48,41,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,84,69,88,84,85,82,69,95,82,69,67,84,10,10,9,105,102,32,40,100,115,116,95,114,101,99,116,46,122,32,60,32,48,46,48,41,32,123,32,47,47,32,84,114,97,110,115,112,111,115,101,32,105,115,32,101,110,99,111,100,101,100,32,97,115,32,110,101,103,97,116,105,118,101,32,100,115,116,95,114,101,99,116,46,122,10,9,9,117,118,95,105,110,116,101,114,112,32,61,32,115,114,99,95,114,101,99,116,46,120,121,32,43,32,97,98,115,40,115,114,99,95,114,101,99,116,46,122,119,41,32,42,32,118,101,114,116,101,120,46,121,120,59,10,9,125,32,101,108,115,101,32,123,10,9,9,117,118,95,105,110,116,101,114,112,32,61,32,115,114,99,95,114,101,99,116,46,120,121,32,43,32,97,98,115,40,115,114,99,95,114,101,99,116,46,122,119,41,32,42,32,118,101,114,116,101,120,59,10,9,125,10,9,104,105,103,104,112,32,118,101,99,52,32,111,117,116,118,101,99,32,61,32,118,101,99,52,40,100,115,116,95,114,101,99,116,46,120,121,32,43,32,97,98,115,40,100,115,116,95,114,101,99,116,46,122,119,41,32,42,32,109,105,120,40,118,101,114,116,101,120,44,32,118,101,99,50,40,49,46,48,44,32,49,46,48,41,32,45,32,118,101,114,116,101,120,44,32,108,101,115,115,84,104,97,110,40,115,114,99,95,114,101,99,116,46,122,119,44,32,118,101,99,50,40,48,46,48,44,32,48,46,48,41,41,41,44,32,48,46,48,44,32,49,46,48,41,59,10,10,35,101,108,115,101,10,9,117,118,95,105,110,116,101,114,112,32,61,32,117,118,95,97,116,116,114,105,98,59,10,9,104,105,103,104,112,32,118,101,99,52,32,111,117,116,118,101,99,32,61,32,118,101,99,52,40,118,101,114,116,101,120,44,32,48,46,48,44,32,49,46,48,41,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,80,65,82,84,73,67,76,69,83,10,9,47,47,115,99,97,108,101,32,98,121,32,116,101,120,116,117,114,101,32,115,105,122,101,10,9,111,117,116,118,101,99,46,120,121,32,47,61,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,59,10,35,101,110,100,105,102,10,10,35,100,101,102,105,110,101,32,101,120,116,114,97,95,109,97,116,114,105,120,32,101,120,116,114,97,95,109,97,116,114,105,120,95,105,110,115,116,97,110,99,101,10,10,9,102,108,111,97,116,32,112,111,105,110,116,95,115,105,122,101,32,61,32,49,46,48,59,10,9,47,47,102,111,114,32,99,111,109,112,97,116,105,98,105,108,105,116,121,32,119,105,116,104,32,116,104,101,32,102,114,97,103,109,101,110,116,32,115,104,97,100,101,114,32,119,101,32,110,101,101,100,32,116,111,32,117,115,101,32,117,118,32,104,101,114,101,10,9,118,101,99,50,32,117,118,32,61,32,117,118,95,105,110,116,101,114,112,59,10,9,123,10,9,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,10,86,69,82,84,69,88,95,83,72,65,68,69,82,95,67,79,68,69,10,10,9,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,9,125,10,10,9,103,108,95,80,111,105,110,116,83,105,122,101,32,61,32,112,111,105,110,116,95,115,105,122,101,59,10,9,117,118,95,105,110,116,101,114,112,32,61,32,117,118,59,10,10,35,105,102,100,101,102,32,85,83,69,95,78,73,78,69,80,65,84,67,72,10,10,9,112,105,120,101,108,95,115,105,122,101,95,105,110,116,101,114,112,32,61,32,97,98,115,40,100,115,116,95,114,101,99,116,46,122,119,41,32,42,32,118,101,114,116,101,120,59,10,35,101,110,100,105,102,10,10,35,105,102,32,33,100,101,102,105,110,101,100,40,83,75,73,80,95,84,82,65,78,83,70,79,82,77,95,85,83,69,68,41,10,9,111,117,116,118,101,99,32,61,32,101,120,116,114,97,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,59,10,9,111,117,116,118,101,99,32,61,32,109,111,100,101,108,118,105,101,119,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,59,10,35,101,110,100,105,102,10,10,35,117,110,100,101,102,32,101,120,116,114,97,95,109,97,116,114,105,120,10,10,9,99,111,108,111,114,95,105,110,116,101,114,112,32,61,32,99,111,108,111,114,59,10,10,35,105,102,100,101,102,32,85,83,69,95,80,73,88,69,76,95,83,78,65,80,10,9,111,117,116,118,101,99,46,120,121,32,61,32,102,108,111,111,114,40,111,117,116,118,101,99,32,43,32,48,46,53,41,46,120,121,59,10,9,47,47,32,112,114,101,99,105,115,105,111,110,32,105,115,115,117,101,32,111,110,32,115,111,109,101,32,104,97,114,100,119,97,114,101,32,99,114,101,97,116,101,115,32,97,114,116,105,102,97,99,116,115,32,119,105,116,104,105,110,32,116,101,120,116,117,114,101,10,9,47,47,32,111,102,102,115,101,116,32,117,118,32,98,121,32,97,32,115,109,97,108,108,32,97,109,111,117,110,116,32,116,111,32,97,118,111,105,100,10,9,117,118,95,105,110,116,101,114,112,32,43,61,32,49,101,45,53,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,83,75,69,76,69,84,79,78,10,10,9,105,102,32,40,98,111,110,101,95,119,101,105,103,104,116,115,32,33,61,32,118,101,99,52,40,48,46,48,41,41,32,123,32,47,47,109,117,115,116,32,98,101,32,97,32,118,97,108,105,100,32,98,111,110,101,10,9,9,47,47,115,107,101,108,101,116,111,110,32,116,114,97,110,115,102,111,114,109,10,10,9,9,105,118,101,99,52,32,98,111,110,101,95,105,110,100,105,99,101,115,105,32,61,32,105,118,101,99,52,40,98,111,110,101,95,105,110,100,105,99,101,115,41,59,10,10,9,9,105,118,101,99,50,32,116,101,120,95,111,102,115,32,61,32,105,118,101,99,50,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,120,32,37,32,50,53,54,44,32,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,120,32,47,32,50,53,54,41,32,42,32,50,41,59,10,10,9,9,104,105,103,104,112,32,109,97,116,50,120,52,32,109,59,10,9,9,109,32,61,32,109,97,116,50,120,52,40,10,9,9,9,9,9,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,44,32,48,41,44,10,9,9,9,9,9,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,32,43,32,105,118,101,99,50,40,48,44,32,49,41,44,32,48,41,41,32,42,10,9,9,9,98,111,110,101,95,119,101,105,103,104,116,115,46,120,59,10,10,9,9,116,101,120,95,111,102,115,32,61,32,105,118,101,99,50,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,121,32,37,32,50,53,54,44,32,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,121,32,47,32,50,53,54,41,32,42,32,50,41,59,10,10,9,9,109,32,43,61,32,109,97,116,50,120,52,40,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,44,32,48,41,44,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,32,43,32,105,118,101,99,50,40,48,44,32,49,41,44,32,48,41,41,32,42,10,9,9,9,32,98,111,110,101,95,119,101,105,103,104,116,115,46,121,59,10,10,9,9,116,101,120,95,111,102,115,32,61,32,105,118,101,99,50,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,122,32,37,32,50,53,54,44,32,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,122,32,47,32,50,53,54,41,32,42,32,50,41,59,10,10,9,9,109,32,43,61,32,109,97,116,50,120,52,40,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,44,32,48,41,44,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,32,43,32,105,118,101,99,50,40,48,44,32,49,41,44,32,48,41,41,32,42,10,9,9,9,32,98,111,110,101,95,119,101,105,103,104,116,115,46,122,59,10,10,9,9,116,101,120,95,111,102,115,32,61,32,105,118,101,99,50,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,119,32,37,32,50,53,54,44,32,40,98,111,110,101,95,105,110,100,105,99,101,115,105,46,119,32,47,32,50,53,54,41,32,42,32,50,41,59,10,10,9,9,109,32,43,61,32,109,97,116,50,120,52,40,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,44,32,48,41,44,10,9,9,9,9,9,32,116,101,120,101,108,70,101,116,99,104,40,115,107,101,108,101,116,111,110,95,116,101,120,116,117,114,101,44,32,116,101,120,95,111,102,115,32,43,32,105,118,101,99,50,40,48,44,32,49,41,44,32,48,41,41,32,42,10,9,9,9,32,98,111,110,101,95,119,101,105,103,104,116,115,46,119,59,10,10,9,9,109,97,116,52,32,98,111,110,101,95,109,97,116,114,105,120,32,61,32,115,107,101,108,101,116,111,110,95,116,114,97,110,115,102,111,114,109,32,42,32,116,114,97,110,115,112,111,115,101,40,109,97,116,52,40,109,91,48,93,44,32,109,91,49,93,44,32,118,101,99,52,40,48,46,48,44,32,48,46,48,44,32,49,46,48,44,32,48,46,48,41,44,32,118,101,99,52,40,48,46,48,44,32,48,46,48,44,32,48,46,48,44,32,49,46,48,41,41,41,32,42,32,115,107,101,108,101,116,111,110,95,116,114,97,110,115,102,111,114,109,95,105,110,118,101,114,115,101,59,10,10,9,9,111,117,116,118,101,99,32,61,32,98,111,110,101,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,59,10,9,125,10,10,35,101,110,100,105,102,10,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,112,114,111,106,101,99,116,105,111,110,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,59,10,10,35,105,102,100,101,102,32,85,83,69,95,76,73,71,72,84,73,78,71,10,10,9,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,120,121,32,61,32,40,108,105,103,104,116,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,41,46,120,121,59,10,9,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,122,119,32,61,32,40,108,105,103,104,116,95,108,111,99,97,108,95,109,97,116,114,105,120,32,42,32,111,117,116,118,101,99,41,46,120,121,59,10,10,9,109,97,116,51,32,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,32,61,32,109,97,116,51,40,105,110,118,101,114,115,101,40,108,105,103,104,116,95,109,97,116,114,105,120,41,41,59,10,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,48,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,48,93,41,59,10,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,49,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,49,93,41,59,10,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,50,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,50,93,41,59,10,9,116,114,97,110,115,102,111,114,109,101,100,95,108,105,103,104,116,95,117,118,32,61,32,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,32,42,32,118,101,99,51,40,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,122,119,44,32,48,46,48,41,41,46,120,121,59,32,47,47,102,111,114,32,110,111,114,109,97,108,32,109,97,112,112,105,110,103,10,10,35,105,102,100,101,102,32,85,83,69,95,83,72,65,68,79,87,83,10,9,112,111,115,32,61,32,111,117,116,118,101,99,46,120,121,59,10,35,101,110,100,105,102,10,10,9,108,111,99,97,108,95,114,111,116,46,120,121,32,61,32,110,111,114,109,97,108,105,122,101,40,40,109,111,100,101,108,118,105,101,119,95,109,97,116,114,105,120,32,42,32,40,101,120,116,114,97,95,109,97,116,114,105,120,95,105,110,115,116,97,110,99,101,32,42,32,118,101,99,52,40,49,46,48,44,32,48,46,48,44,32,48,46,48,44,32,48,46,48,41,41,41,46,120,121,41,59,10,9,108,111,99,97,108,95,114,111,116,46,122,119,32,61,32,110,111,114,109,97,108,105,122,101,40,40,109,111,100,101,108,118,105,101,119,95,109,97,116,114,105,120,32,42,32,40,101,120,116,114,97,95,109,97,116,114,105,120,95,105,110,115,116,97,110,99,101,32,42,32,118,101,99,52,40,48,46,48,44,32,49,46,48,44,32,48,46,48,44,32,48,46,48,41,41,41,46,120,121,41,59,10,35,105,102,100,101,102,32,85,83,69,95,84,69,88,84,85,82,69,95,82,69,67,84,10,9,108,111,99,97,108,95,114,111,116,46,120,121,32,42,61,32,115,105,103,110,40,115,114,99,95,114,101,99,116,46,122,41,59,10,9,108,111,99,97,108,95,114,111,116,46,122,119,32,42,61,32,115,105,103,110,40,115,114,99,95,114,101,99,116,46,119,41,59,10,35,101,110,100,105,102,10,10,35,101,110,100,105,102,10,125,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,		0};

		static const int _vertex_code_start=2;
		static const char _fragment_code[]={
10,117,110,105,102,111,114,109,32,109,101,100,105,117,109,112,32,115,97,109,112,108,101,114,50,68,32,99,111,108,111,114,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,48,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,118,101,99,50,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,59,10,117,110,105,102,111,114,109,32,109,101,100,105,117,109,112,32,115,97,109,112,108,101,114,50,68,32,110,111,114,109,97,108,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,49,10,10,105,110,32,104,105,103,104,112,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,105,110,32,109,101,100,105,117,109,112,32,118,101,99,52,32,99,111,108,111,114,95,105,110,116,101,114,112,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,83,67,82,69,69,78,95,84,69,88,84,85,82,69,95,85,83,69,68,41,10,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,99,114,101,101,110,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,45,51,10,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,83,67,82,69,69,78,95,85,86,95,85,83,69,68,41,10,10,117,110,105,102,111,114,109,32,118,101,99,50,32,115,99,114,101,101,110,95,112,105,120,101,108,95,115,105,122,101,59,10,35,101,110,100,105,102,10,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,67,97,110,118,97,115,73,116,101,109,68,97,116,97,32,123,10,10,9,104,105,103,104,112,32,109,97,116,52,32,112,114,111,106,101,99,116,105,111,110,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,116,105,109,101,59,10,125,59,10,10,35,105,102,100,101,102,32,85,83,69,95,76,73,71,72,84,73,78,71,10,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,76,105,103,104,116,68,97,116,97,32,123,10,10,9,104,105,103,104,112,32,109,97,116,52,32,108,105,103,104,116,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,109,97,116,52,32,108,105,103,104,116,95,108,111,99,97,108,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,109,97,116,52,32,115,104,97,100,111,119,95,109,97,116,114,105,120,59,10,9,104,105,103,104,112,32,118,101,99,52,32,108,105,103,104,116,95,99,111,108,111,114,59,10,9,104,105,103,104,112,32,118,101,99,52,32,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,59,10,9,104,105,103,104,112,32,118,101,99,50,32,108,105,103,104,116,95,112,111,115,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,95,103,114,97,100,105,101,110,116,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,108,105,103,104,116,95,104,101,105,103,104,116,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,108,105,103,104,116,95,111,117,116,115,105,100,101,95,97,108,112,104,97,59,10,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,95,100,105,115,116,97,110,99,101,95,109,117,108,116,59,10,125,59,10,10,117,110,105,102,111,114,109,32,108,111,119,112,32,115,97,109,112,108,101,114,50,68,32,108,105,103,104,116,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,45,49,10,105,110,32,118,101,99,52,32,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,59,10,105,110,32,118,101,99,50,32,116,114,97,110,115,102,111,114,109,101,100,95,108,105,103,104,116,95,117,118,59,10,10,105,110,32,118,101,99,52,32,108,111,99,97,108,95,114,111,116,59,10,10,35,105,102,100,101,102,32,85,83,69,95,83,72,65,68,79,87,83,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,115,97,109,112,108,101,114,50,68,32,115,104,97,100,111,119,95,116,101,120,116,117,114,101,59,32,47,47,32,116,101,120,117,110,105,116,58,45,50,10,105,110,32,104,105,103,104,112,32,118,101,99,50,32,112,111,115,59,10,10,35,101,110,100,105,102,10,10,99,111,110,115,116,32,98,111,111,108,32,97,116,95,108,105,103,104,116,95,112,97,115,115,32,61,32,116,114,117,101,59,10,35,101,108,115,101,10,99,111,110,115,116,32,98,111,111,108,32,97,116,95,108,105,103,104,116,95,112,97,115,115,32,61,32,102,97,108,115,101,59,10,35,101,110,100,105,102,10,10,117,110,105,102,111,114,109,32,109,101,100,105,117,109,112,32,118,101,99,52,32,102,105,110,97,108,95,109,111,100,117,108,97,116,101,59,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,111,117,116,32,109,101,100,105,117,109,112,32,118,101,99,52,32,102,114,97,103,95,99,111,108,111,114,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,77,65,84,69,82,73,65,76,41,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,108,97,121,111,117,116,40,115,116,100,49,52,48,41,32,117,110,105,102,111,114,109,32,85,110,105,102,111,114,109,68,97,116,97,32,123,10,10,77,65,84,69,82,73,65,76,95,85,78,73,70,79,82,77,83,10,10,125,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,101,110,100,105,102,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,10,70,82,65,71,77,69,78,84,95,83,72,65,68,69,82,95,71,76,79,66,65,76,83,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,118,111,105,100,32,108,105,103,104,116,95,99,111,109,112,117,116,101,40,10,9,9,105,110,111,117,116,32,118,101,99,52,32,108,105,103,104,116,44,10,9,9,105,110,111,117,116,32,118,101,99,50,32,108,105,103,104,116,95,118,101,99,44,10,9,9,105,110,111,117,116,32,102,108,111,97,116,32,108,105,103,104,116,95,104,101,105,103,104,116,44,10,9,9,105,110,111,117,116,32,118,101,99,52,32,108,105,103,104,116,95,99,111,108,111,114,44,10,9,9,118,101,99,50,32,108,105,103,104,116,95,117,118,44,10,9,9,105,110,111,117,116,32,118,101,99,52,32,115,104,97,100,111,119,95,99,111,108,111,114,44,10,9,9,105,110,111,117,116,32,118,101,99,50,32,115,104,97,100,111,119,95,118,101,99,44,10,9,9,118,101,99,51,32,110,111,114,109,97,108,44,10,9,9,118,101,99,50,32,117,118,44,10,35,105,102,32,100,101,102,105,110,101,100,40,83,67,82,69,69,78,95,85,86,95,85,83,69,68,41,10,9,9,118,101,99,50,32,115,99,114,101,101,110,95,117,118,44,10,35,101,110,100,105,102,10,9,9,118,101,99,52,32,99,111,108,111,114,41,32,123,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,76,73,71,72,84,95,83,72,65,68,69,82,95,67,79,68,69,41,10,10,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,10,76,73,71,72,84,95,83,72,65,68,69,82,95,67,79,68,69,10,10,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,101,110,100,105,102,10,125,10,10,35,105,102,100,101,102,32,85,83,69,95,84,69,88,84,85,82,69,95,82,69,67,84,10,10,117,110,105,102,111,114,109,32,118,101,99,52,32,100,115,116,95,114,101,99,116,59,10,117,110,105,102,111,114,109,32,118,101,99,52,32,115,114,99,95,114,101,99,116,59,10,117,110,105,102,111,114,109,32,98,111,111,108,32,99,108,105,112,95,114,101,99,116,95,117,118,59,10,10,35,105,102,100,101,102,32,85,83,69,95,78,73,78,69,80,65,84,67,72,10,10,105,110,32,104,105,103,104,112,32,118,101,99,50,32,112,105,120,101,108,95,115,105,122,101,95,105,110,116,101,114,112,59,10,10,117,110,105,102,111,114,109,32,105,110,116,32,110,112,95,114,101,112,101,97,116,95,118,59,10,117,110,105,102,111,114,109,32,105,110,116,32,110,112,95,114,101,112,101,97,116,95,104,59,10,117,110,105,102,111,114,109,32,98,111,111,108,32,110,112,95,100,114,97,119,95,99,101,110,116,101,114,59,10,47,47,32,108,101,102,116,32,116,111,112,32,114,105,103,104,116,32,98,111,116,116,111,109,32,105,110,32,112,105,120,101,108,32,99,111,111,114,100,105,110,97,116,101,115,10,117,110,105,102,111,114,109,32,118,101,99,52,32,110,112,95,109,97,114,103,105,110,115,59,10,10,102,108,111,97,116,32,109,97,112,95,110,105,110,101,112,97,116,99,104,95,97,120,105,115,40,102,108,111,97,116,32,112,105,120,101,108,44,32,102,108,111,97,116,32,100,114,97,119,95,115,105,122,101,44,32,102,108,111,97,116,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,44,32,102,108,111,97,116,32,109,97,114,103,105,110,95,98,101,103,105,110,44,32,102,108,111,97,116,32,109,97,114,103,105,110,95,101,110,100,44,32,102,108,111,97,116,32,115,95,114,97,116,105,111,44,32,105,110,116,32,110,112,95,114,101,112,101,97,116,44,32,105,110,111,117,116,32,105,110,116,32,100,114,97,119,95,99,101,110,116,101,114,41,32,123,10,10,9,102,108,111,97,116,32,116,101,120,95,115,105,122,101,32,61,32,49,46,48,32,47,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,10,9,102,108,111,97,116,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,32,61,32,109,97,114,103,105,110,95,98,101,103,105,110,32,47,32,115,95,114,97,116,105,111,59,10,9,102,108,111,97,116,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,101,110,100,32,61,32,109,97,114,103,105,110,95,101,110,100,32,47,32,115,95,114,97,116,105,111,59,10,9,105,102,32,40,112,105,120,101,108,32,60,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,41,32,123,10,9,9,114,101,116,117,114,110,32,112,105,120,101,108,32,42,32,115,95,114,97,116,105,111,32,42,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,9,125,32,101,108,115,101,32,105,102,32,40,112,105,120,101,108,32,62,61,32,100,114,97,119,95,115,105,122,101,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,101,110,100,41,32,123,10,9,9,114,101,116,117,114,110,32,40,116,101,120,95,115,105,122,101,32,45,32,40,100,114,97,119,95,115,105,122,101,32,45,32,112,105,120,101,108,41,32,42,32,115,95,114,97,116,105,111,41,32,42,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,9,125,32,101,108,115,101,32,123,10,9,9,105,102,32,40,33,110,112,95,100,114,97,119,95,99,101,110,116,101,114,41,32,123,10,9,9,9,100,114,97,119,95,99,101,110,116,101,114,45,45,59,10,9,9,125,10,10,9,9,47,47,32,110,112,95,114,101,112,101,97,116,32,105,115,32,112,97,115,115,101,100,32,97,115,32,117,110,105,102,111,114,109,32,117,115,105,110,103,32,78,105,110,101,80,97,116,99,104,82,101,99,116,58,58,65,120,105,115,83,116,114,101,116,99,104,77,111,100,101,32,101,110,117,109,46,10,9,9,105,102,32,40,110,112,95,114,101,112,101,97,116,32,61,61,32,48,41,32,123,32,47,47,32,83,116,114,101,116,99,104,46,10,9,9,9,47,47,32,67,111,110,118,101,114,116,32,116,111,32,114,97,116,105,111,46,10,9,9,9,102,108,111,97,116,32,114,97,116,105,111,32,61,32,40,112,105,120,101,108,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,41,32,47,32,40,100,114,97,119,95,115,105,122,101,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,101,110,100,41,59,10,9,9,9,47,47,32,83,99,97,108,101,32,116,111,32,115,111,117,114,99,101,32,116,101,120,116,117,114,101,46,10,9,9,9,114,101,116,117,114,110,32,40,109,97,114,103,105,110,95,98,101,103,105,110,32,43,32,114,97,116,105,111,32,42,32,40,116,101,120,95,115,105,122,101,32,45,32,109,97,114,103,105,110,95,98,101,103,105,110,32,45,32,109,97,114,103,105,110,95,101,110,100,41,41,32,42,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,9,9,125,32,101,108,115,101,32,105,102,32,40,110,112,95,114,101,112,101,97,116,32,61,61,32,49,41,32,123,32,47,47,32,84,105,108,101,46,10,9,9,9,47,47,32,67,111,110,118,101,114,116,32,116,111,32,111,102,102,115,101,116,46,10,9,9,9,102,108,111,97,116,32,111,102,115,32,61,32,109,111,100,40,40,112,105,120,101,108,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,41,44,32,116,101,120,95,115,105,122,101,32,45,32,109,97,114,103,105,110,95,98,101,103,105,110,32,45,32,109,97,114,103,105,110,95,101,110,100,41,59,10,9,9,9,47,47,32,83,99,97,108,101,32,116,111,32,115,111,117,114,99,101,32,116,101,120,116,117,114,101,46,10,9,9,9,114,101,116,117,114,110,32,40,109,97,114,103,105,110,95,98,101,103,105,110,32,43,32,111,102,115,41,32,42,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,9,9,125,32,101,108,115,101,32,105,102,32,40,110,112,95,114,101,112,101,97,116,32,61,61,32,50,41,32,123,32,47,47,32,84,105,108,101,32,70,105,116,46,10,9,9,9,47,47,32,67,97,108,99,117,108,97,116,101,32,115,99,97,108,101,46,10,9,9,9,102,108,111,97,116,32,115,114,99,95,97,114,101,97,32,61,32,100,114,97,119,95,115,105,122,101,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,101,110,100,59,10,9,9,9,102,108,111,97,116,32,100,115,116,95,97,114,101,97,32,61,32,116,101,120,95,115,105,122,101,32,45,32,109,97,114,103,105,110,95,98,101,103,105,110,32,45,32,109,97,114,103,105,110,95,101,110,100,59,10,9,9,9,102,108,111,97,116,32,115,99,97,108,101,32,61,32,109,97,120,40,49,46,48,44,32,102,108,111,111,114,40,115,114,99,95,97,114,101,97,32,47,32,109,97,120,40,100,115,116,95,97,114,101,97,44,32,48,46,48,48,48,48,48,48,49,41,32,43,32,48,46,53,41,41,59,10,9,9,9,47,47,32,67,111,110,118,101,114,116,32,116,111,32,114,97,116,105,111,46,10,9,9,9,102,108,111,97,116,32,114,97,116,105,111,32,61,32,40,112,105,120,101,108,32,45,32,115,99,114,101,101,110,95,109,97,114,103,105,110,95,98,101,103,105,110,41,32,47,32,115,114,99,95,97,114,101,97,59,10,9,9,9,114,97,116,105,111,32,61,32,109,111,100,40,114,97,116,105,111,32,42,32,115,99,97,108,101,44,32,49,46,48,41,59,10,9,9,9,47,47,32,83,99,97,108,101,32,116,111,32,115,111,117,114,99,101,32,116,101,120,116,117,114,101,46,10,9,9,9,114,101,116,117,114,110,32,40,109,97,114,103,105,110,95,98,101,103,105,110,32,43,32,114,97,116,105,111,32,42,32,100,115,116,95,97,114,101,97,41,32,42,32,116,101,120,95,112,105,120,101,108,95,115,105,122,101,59,10,9,9,125,32,101,108,115,101,32,123,32,47,47,32,83,104,111,117,108,100,110,39,116,32,104,97,112,112,101,110,44,32,98,117,116,32,115,105,108,101,110,99,101,115,32,99,111,109,112,105,108,101,114,32,119,97,114,110,105,110,103,46,10,9,9,9,114,101,116,117,114,110,32,48,46,48,59,10,9,9,125,10,9,125,10,125,10,10,35,101,110,100,105,102,10,35,101,110,100,105,102,10,10,117,110,105,102,111,114,109,32,98,111,111,108,32,117,115,101,95,100,101,102,97,117,108,116,95,110,111,114,109,97,108,59,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,99,111,108,111,114,95,105,110,116,101,114,112,59,10,9,118,101,99,50,32,117,118,32,61,32,117,118,95,105,110,116,101,114,112,59,10,10,35,105,102,100,101,102,32,85,83,69,95,84,69,88,84,85,82,69,95,82,69,67,84,10,10,35,105,102,100,101,102,32,85,83,69,95,78,73,78,69,80,65,84,67,72,10,10,9,105,110,116,32,100,114,97,119,95,99,101,110,116,101,114,32,61,32,50,59,10,9,102,108,111,97,116,32,115,95,114,97,116,105,111,32,61,32,109,97,120,40,40,49,46,48,32,47,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,46,120,41,32,47,32,97,98,115,40,100,115,116,95,114,101,99,116,46,122,41,44,32,40,49,46,48,32,47,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,46,121,41,32,47,32,97,98,115,40,100,115,116,95,114,101,99,116,46,119,41,41,59,10,9,115,95,114,97,116,105,111,32,61,32,109,97,120,40,49,46,48,44,32,115,95,114,97,116,105,111,41,59,10,9,117,118,32,61,32,118,101,99,50,40,10,9,9,9,109,97,112,95,110,105,110,101,112,97,116,99,104,95,97,120,105,115,40,112,105,120,101,108,95,115,105,122,101,95,105,110,116,101,114,112,46,120,44,32,97,98,115,40,100,115,116,95,114,101,99,116,46,122,41,44,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,46,120,44,32,110,112,95,109,97,114,103,105,110,115,46,120,44,32,110,112,95,109,97,114,103,105,110,115,46,122,44,32,115,95,114,97,116,105,111,44,32,110,112,95,114,101,112,101,97,116,95,104,44,32,100,114,97,119,95,99,101,110,116,101,114,41,44,10,9,9,9,109,97,112,95,110,105,110,101,112,97,116,99,104,95,97,120,105,115,40,112,105,120,101,108,95,115,105,122,101,95,105,110,116,101,114,112,46,121,44,32,97,98,115,40,100,115,116,95,114,101,99,116,46,119,41,44,32,99,111,108,111,114,95,116,101,120,112,105,120,101,108,95,115,105,122,101,46,121,44,32,110,112,95,109,97,114,103,105,110,115,46,121,44,32,110,112,95,109,97,114,103,105,110,115,46,119,44,32,115,95,114,97,116,105,111,44,32,110,112,95,114,101,112,101,97,116,95,118,44,32,100,114,97,119,95,99,101,110,116,101,114,41,41,59,10,10,9,105,102,32,40,100,114,97,119,95,99,101,110,116,101,114,32,61,61,32,48,41,32,123,10,9,9,99,111,108,111,114,46,97,32,61,32,48,46,48,59,10,9,125,10,10,9,117,118,32,61,32,117,118,32,42,32,115,114,99,95,114,101,99,116,46,122,119,32,43,32,115,114,99,95,114,101,99,116,46,120,121,59,32,47,47,97,112,112,108,121,32,114,101,103,105,111,110,32,105,102,32,110,101,101,100,101,100,10,35,101,110,100,105,102,10,10,9,105,102,32,40,99,108,105,112,95,114,101,99,116,95,117,118,41,32,123,10,10,9,9,117,118,32,61,32,99,108,97,109,112,40,117,118,44,32,115,114,99,95,114,101,99,116,46,120,121,44,32,115,114,99,95,114,101,99,116,46,120,121,32,43,32,97,98,115,40,115,114,99,95,114,101,99,116,46,122,119,41,41,59,10,9,125,10,10,35,101,110,100,105,102,10,10,35,105,102,32,33,100,101,102,105,110,101,100,40,67,79,76,79,82,95,85,83,69,68,41,10,9,47,47,100,101,102,97,117,108,116,32,98,101,104,97,118,105,111,114,44,32,116,101,120,116,117,114,101,32,98,121,32,99,111,108,111,114,10,10,35,105,102,100,101,102,32,85,83,69,95,68,73,83,84,65,78,67,69,95,70,73,69,76,68,10,9,99,111,110,115,116,32,102,108,111,97,116,32,115,109,111,111,116,104,105,110,103,32,61,32,49,46,48,32,47,32,51,50,46,48,59,10,9,102,108,111,97,116,32,100,105,115,116,97,110,99,101,32,61,32,116,101,120,116,117,114,101,76,111,100,40,99,111,108,111,114,95,116,101,120,116,117,114,101,44,32,117,118,44,32,48,46,48,41,46,97,59,10,9,99,111,108,111,114,46,97,32,61,32,115,109,111,111,116,104,115,116,101,112,40,48,46,53,32,45,32,115,109,111,111,116,104,105,110,103,44,32,48,46,53,32,43,32,115,109,111,111,116,104,105,110,103,44,32,100,105,115,116,97,110,99,101,41,32,42,32,99,111,108,111,114,46,97,59,10,35,101,108,115,101,10,9,99,111,108,111,114,32,42,61,32,116,101,120,116,117,114,101,40,99,111,108,111,114,95,116,101,120,116,117,114,101,44,32,117,118,41,59,10,10,35,101,110,100,105,102,10,10,35,101,110,100,105,102,10,10,9,118,101,99,51,32,110,111,114,109,97,108,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,78,79,82,77,65,76,95,85,83,69,68,41,10,10,9,98,111,111,108,32,110,111,114,109,97,108,95,117,115,101,100,32,61,32,116,114,117,101,59,10,35,101,108,115,101,10,9,98,111,111,108,32,110,111,114,109,97,108,95,117,115,101,100,32,61,32,102,97,108,115,101,59,10,35,101,110,100,105,102,10,10,9,105,102,32,40,117,115,101,95,100,101,102,97,117,108,116,95,110,111,114,109,97,108,41,32,123,10,9,9,110,111,114,109,97,108,46,120,121,32,61,32,116,101,120,116,117,114,101,76,111,100,40,110,111,114,109,97,108,95,116,101,120,116,117,114,101,44,32,117,118,44,32,48,46,48,41,46,120,121,32,42,32,50,46,48,32,45,32,49,46,48,59,10,9,9,110,111,114,109,97,108,46,122,32,61,32,115,113,114,116,40,49,46,48,32,45,32,100,111,116,40,110,111,114,109,97,108,46,120,121,44,32,110,111,114,109,97,108,46,120,121,41,41,59,10,9,9,110,111,114,109,97,108,95,117,115,101,100,32,61,32,116,114,117,101,59,10,9,125,32,101,108,115,101,32,123,10,9,9,110,111,114,109,97,108,32,61,32,118,101,99,51,40,48,46,48,44,32,48,46,48,44,32,49,46,48,41,59,10,9,125,10,10,35,105,102,32,100,101,102,105,110,101,100,40,83,67,82,69,69,78,95,85,86,95,85,83,69,68,41,10,9,118,101,99,50,32,115,99,114,101,101,110,95,117,118,32,61,32,103,108,95,70,114,97,103,67,111,111,114,100,46,120,121,32,42,32,115,99,114,101,101,110,95,112,105,120,101,108,95,115,105,122,101,59,10,35,101,110,100,105,102,10,10,9,123,10,9,9,102,108,111,97,116,32,110,111,114,109,97,108,95,100,101,112,116,104,32,61,32,49,46,48,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,78,79,82,77,65,76,77,65,80,95,85,83,69,68,41,10,9,9,118,101,99,51,32,110,111,114,109,97,108,95,109,97,112,32,61,32,118,101,99,51,40,48,46,48,44,32,48,46,48,44,32,49,46,48,41,59,10,9,9,110,111,114,109,97,108,95,117,115,101,100,32,61,32,116,114,117,101,59,10,35,101,110,100,105,102,10,10,9,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,10,70,82,65,71,77,69,78,84,95,83,72,65,68,69,82,95,67,79,68,69,10,10,9,9,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,35,105,102,32,100,101,102,105,110,101,100,40,78,79,82,77,65,76,77,65,80,95,85,83,69,68,41,10,9,9,110,111,114,109,97,108,32,61,32,109,105,120,40,118,101,99,51,40,48,46,48,44,32,48,46,48,44,32,49,46,48,41,44,32,110,111,114,109,97,108,95,109,97,112,32,42,32,118,101,99,51,40,50,46,48,44,32,45,50,46,48,44,32,49,46,48,41,32,45,32,118,101,99,51,40,49,46,48,44,32,45,49,46,48,44,32,48,46,48,41,44,32,110,111,114,109,97,108,95,100,101,112,116,104,41,59,10,35,101,110,100,105,102,10,9,125,10,35,105,102,100,101,102,32,68,69,66,85,71,95,69,78,67,79,68,69,68,95,51,50,10,9,104,105,103,104,112,32,102,108,111,97,116,32,101,110,99,51,50,32,61,32,100,111,116,40,99,111,108,111,114,44,32,104,105,103,104,112,32,118,101,99,52,40,49,46,48,32,47,32,40,50,53,54,46,48,32,42,32,50,53,54,46,48,32,42,32,50,53,54,46,48,41,44,32,49,46,48,32,47,32,40,50,53,54,46,48,32,42,32,50,53,54,46,48,41,44,32,49,46,48,32,47,32,50,53,54,46,48,44,32,49,46,48,41,41,59,10,9,99,111,108,111,114,32,61,32,118,101,99,52,40,118,101,99,51,40,101,110,99,51,50,41,44,32,49,46,48,41,59,10,35,101,110,100,105,102,10,10,35,105,102,32,33,100,101,102,105,110,101,100,40,77,79,68,85,76,65,84,69,95,85,83,69,68,41,10,9,99,111,108,111,114,32,42,61,32,102,105,110,97,108,95,109,111,100,117,108,97,116,101,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,76,73,71,72,84,73,78,71,10,10,9,118,101,99,50,32,108,105,103,104,116,95,118,101,99,32,61,32,116,114,97,110,115,102,111,114,109,101,100,95,108,105,103,104,116,95,117,118,59,10,9,118,101,99,50,32,115,104,97,100,111,119,95,118,101,99,32,61,32,116,114,97,110,115,102,111,114,109,101,100,95,108,105,103,104,116,95,117,118,59,10,10,9,105,102,32,40,110,111,114,109,97,108,95,117,115,101,100,41,32,123,10,9,9,110,111,114,109,97,108,46,120,121,32,61,32,109,97,116,50,40,108,111,99,97,108,95,114,111,116,46,120,121,44,32,108,111,99,97,108,95,114,111,116,46,122,119,41,32,42,32,110,111,114,109,97,108,46,120,121,59,10,9,125,10,10,9,102,108,111,97,116,32,97,116,116,32,61,32,49,46,48,59,10,10,9,118,101,99,50,32,108,105,103,104,116,95,117,118,32,61,32,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,120,121,59,10,9,118,101,99,52,32,108,105,103,104,116,32,61,32,116,101,120,116,117,114,101,40,108,105,103,104,116,95,116,101,120,116,117,114,101,44,32,108,105,103,104,116,95,117,118,41,59,10,10,9,105,102,32,40,97,110,121,40,108,101,115,115,84,104,97,110,40,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,120,121,44,32,118,101,99,50,40,48,46,48,44,32,48,46,48,41,41,41,32,124,124,32,97,110,121,40,103,114,101,97,116,101,114,84,104,97,110,69,113,117,97,108,40,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,120,121,44,32,118,101,99,50,40,49,46,48,44,32,49,46,48,41,41,41,41,32,123,10,9,9,99,111,108,111,114,46,97,32,42,61,32,108,105,103,104,116,95,111,117,116,115,105,100,101,95,97,108,112,104,97,59,32,47,47,105,110,118,105,115,105,98,108,101,10,10,9,125,32,101,108,115,101,32,123,10,9,9,102,108,111,97,116,32,114,101,97,108,95,108,105,103,104,116,95,104,101,105,103,104,116,32,61,32,108,105,103,104,116,95,104,101,105,103,104,116,59,10,9,9,118,101,99,52,32,114,101,97,108,95,108,105,103,104,116,95,99,111,108,111,114,32,61,32,108,105,103,104,116,95,99,111,108,111,114,59,10,9,9,118,101,99,52,32,114,101,97,108,95,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,32,61,32,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,76,73,71,72,84,95,83,72,65,68,69,82,95,67,79,68,69,41,10,9,9,47,47,108,105,103,104,116,32,105,115,32,119,114,105,116,116,101,110,32,98,121,32,116,104,101,32,108,105,103,104,116,32,115,104,97,100,101,114,10,9,9,108,105,103,104,116,95,99,111,109,112,117,116,101,40,10,9,9,9,9,108,105,103,104,116,44,10,9,9,9,9,108,105,103,104,116,95,118,101,99,44,10,9,9,9,9,114,101,97,108,95,108,105,103,104,116,95,104,101,105,103,104,116,44,10,9,9,9,9,114,101,97,108,95,108,105,103,104,116,95,99,111,108,111,114,44,10,9,9,9,9,108,105,103,104,116,95,117,118,44,10,9,9,9,9,114,101,97,108,95,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,44,10,9,9,9,9,115,104,97,100,111,119,95,118,101,99,44,10,9,9,9,9,110,111,114,109,97,108,44,10,9,9,9,9,117,118,44,10,35,105,102,32,100,101,102,105,110,101,100,40,83,67,82,69,69,78,95,85,86,95,85,83,69,68,41,10,9,9,9,9,115,99,114,101,101,110,95,117,118,44,10,35,101,110,100,105,102,10,9,9,9,9,99,111,108,111,114,41,59,10,35,101,110,100,105,102,10,10,9,9,108,105,103,104,116,32,42,61,32,114,101,97,108,95,108,105,103,104,116,95,99,111,108,111,114,59,10,10,9,9,105,102,32,40,110,111,114,109,97,108,95,117,115,101,100,41,32,123,10,9,9,9,118,101,99,51,32,108,105,103,104,116,95,110,111,114,109,97,108,32,61,32,110,111,114,109,97,108,105,122,101,40,118,101,99,51,40,108,105,103,104,116,95,118,101,99,44,32,45,114,101,97,108,95,108,105,103,104,116,95,104,101,105,103,104,116,41,41,59,10,9,9,9,108,105,103,104,116,32,42,61,32,109,97,120,40,100,111,116,40,45,108,105,103,104,116,95,110,111,114,109,97,108,44,32,110,111,114,109,97,108,41,44,32,48,46,48,41,59,10,9,9,125,10,10,9,9,99,111,108,111,114,32,42,61,32,108,105,103,104,116,59,10,10,35,105,102,100,101,102,32,85,83,69,95,83,72,65,68,79,87,83,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,86,69,67,95,85,83,69,68,10,9,9,109,97,116,51,32,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,32,61,32,109,97,116,51,40,108,105,103,104,116,95,109,97,116,114,105,120,41,59,10,9,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,48,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,48,93,41,59,10,9,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,49,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,49,93,41,59,10,9,9,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,50,93,32,61,32,110,111,114,109,97,108,105,122,101,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,91,50,93,41,59,10,9,9,115,104,97,100,111,119,95,118,101,99,32,61,32,40,109,97,116,51,40,105,110,118,101,114,115,101,95,108,105,103,104,116,95,109,97,116,114,105,120,41,32,42,32,118,101,99,51,40,115,104,97,100,111,119,95,118,101,99,44,32,48,46,48,41,41,46,120,121,59,10,35,101,108,115,101,10,9,9,115,104,97,100,111,119,95,118,101,99,32,61,32,108,105,103,104,116,95,117,118,95,105,110,116,101,114,112,46,122,119,59,10,35,101,110,100,105,102,10,9,9,102,108,111,97,116,32,97,110,103,108,101,95,116,111,95,108,105,103,104,116,32,61,32,45,97,116,97,110,40,115,104,97,100,111,119,95,118,101,99,46,120,44,32,115,104,97,100,111,119,95,118,101,99,46,121,41,59,10,9,9,102,108,111,97,116,32,80,73,32,61,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,50,51,56,52,54,50,54,52,59,10,9,9,47,42,105,110,116,32,105,32,61,32,105,110,116,40,109,111,100,40,102,108,111,111,114,40,40,97,110,103,108,101,95,116,111,95,108,105,103,104,116,43,55,46,48,42,80,73,47,54,46,48,41,47,40,52,46,48,42,80,73,47,54,46,48,41,41,43,49,46,48,44,32,51,46,48,41,41,59,32,47,47,32,43,49,32,112,113,32,111,115,32,105,110,100,105,99,101,115,32,101,115,116,97,111,32,101,109,32,111,114,100,101,109,32,50,44,48,44,49,32,110,111,115,32,97,114,114,97,121,115,10,9,9,102,108,111,97,116,32,97,110,103,42,47,10,10,9,9,102,108,111,97,116,32,115,117,44,32,115,122,59,10,10,9,9,102,108,111,97,116,32,97,98,115,95,97,110,103,108,101,32,61,32,97,98,115,40,97,110,103,108,101,95,116,111,95,108,105,103,104,116,41,59,10,9,9,118,101,99,50,32,112,111,105,110,116,59,10,9,9,102,108,111,97,116,32,115,104,59,10,9,9,105,102,32,40,97,98,115,95,97,110,103,108,101,32,60,32,52,53,46,48,32,42,32,80,73,32,47,32,49,56,48,46,48,41,32,123,10,9,9,9,112,111,105,110,116,32,61,32,115,104,97,100,111,119,95,118,101,99,59,10,9,9,9,115,104,32,61,32,48,46,48,32,43,32,40,49,46,48,32,47,32,56,46,48,41,59,10,9,9,125,32,101,108,115,101,32,105,102,32,40,97,98,115,95,97,110,103,108,101,32,62,32,49,51,53,46,48,32,42,32,80,73,32,47,32,49,56,48,46,48,41,32,123,10,9,9,9,112,111,105,110,116,32,61,32,45,115,104,97,100,111,119,95,118,101,99,59,10,9,9,9,115,104,32,61,32,48,46,53,32,43,32,40,49,46,48,32,47,32,56,46,48,41,59,10,9,9,125,32,101,108,115,101,32,105,102,32,40,97,110,103,108,101,95,116,111,95,108,105,103,104,116,32,62,32,48,46,48,41,32,123,10,10,9,9,9,112,111,105,110,116,32,61,32,118,101,99,50,40,115,104,97,100,111,119,95,118,101,99,46,121,44,32,45,115,104,97,100,111,119,95,118,101,99,46,120,41,59,10,9,9,9,115,104,32,61,32,48,46,50,53,32,43,32,40,49,46,48,32,47,32,56,46,48,41,59,10,9,9,125,32,101,108,115,101,32,123,10,10,9,9,9,112,111,105,110,116,32,61,32,118,101,99,50,40,45,115,104,97,100,111,119,95,118,101,99,46,121,44,32,115,104,97,100,111,119,95,118,101,99,46,120,41,59,10,9,9,9,115,104,32,61,32,48,46,55,53,32,43,32,40,49,46,48,32,47,32,56,46,48,41,59,10,9,9,125,10,10,9,9,104,105,103,104,112,32,118,101,99,52,32,115,32,61,32,115,104,97,100,111,119,95,109,97,116,114,105,120,32,42,32,118,101,99,52,40,112,111,105,110,116,44,32,48,46,48,44,32,49,46,48,41,59,10,9,9,115,46,120,121,122,32,47,61,32,115,46,119,59,10,9,9,115,117,32,61,32,115,46,120,32,42,32,48,46,53,32,43,32,48,46,53,59,10,9,9,115,122,32,61,32,115,46,122,32,42,32,48,46,53,32,43,32,48,46,53,59,10,9,9,47,47,115,122,61,108,105,103,104,116,108,101,110,103,116,104,40,108,105,103,104,116,95,118,101,99,41,59,10,10,9,9,104,105,103,104,112,32,102,108,111,97,116,32,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,61,32,48,46,48,59,10,10,35,105,102,100,101,102,32,85,83,69,95,82,71,66,65,95,83,72,65,68,79,87,83,10,10,35,100,101,102,105,110,101,32,83,72,65,68,79,87,95,68,69,80,84,72,40,109,95,116,101,120,44,32,109,95,117,118,41,32,100,111,116,40,116,101,120,116,117,114,101,40,40,109,95,116,101,120,41,44,32,40,109,95,117,118,41,41,44,32,118,101,99,52,40,49,46,48,32,47,32,40,50,53,53,46,48,32,42,32,50,53,53,46,48,32,42,32,50,53,53,46,48,41,44,32,49,46,48,32,47,32,40,50,53,53,46,48,32,42,32,50,53,53,46,48,41,44,32,49,46,48,32,47,32,50,53,53,46,48,44,32,49,46,48,41,41,10,10,35,101,108,115,101,10,10,35,100,101,102,105,110,101,32,83,72,65,68,79,87,95,68,69,80,84,72,40,109,95,116,101,120,44,32,109,95,117,118,41,32,40,116,101,120,116,117,114,101,40,40,109,95,116,101,120,41,44,32,40,109,95,117,118,41,41,46,114,41,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,85,83,69,95,71,82,65,68,73,69,78,84,10,10,35,100,101,102,105,110,101,32,83,72,65,68,79,87,95,84,69,83,84,40,109,95,111,102,115,41,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,92,10,9,123,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,92,10,9,9,104,105,103,104,112,32,102,108,111,97,116,32,115,100,32,61,32,83,72,65,68,79,87,95,68,69,80,84,72,40,115,104,97,100,111,119,95,116,101,120,116,117,114,101,44,32,118,101,99,50,40,109,95,111,102,115,44,32,115,104,41,41,59,32,32,32,32,32,32,32,92,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,43,61,32,49,46,48,32,45,32,115,109,111,111,116,104,115,116,101,112,40,115,100,44,32,115,100,32,43,32,115,104,97,100,111,119,95,103,114,97,100,105,101,110,116,44,32,115,122,41,59,32,92,10,9,125,10,10,35,101,108,115,101,10,10,35,100,101,102,105,110,101,32,83,72,65,68,79,87,95,84,69,83,84,40,109,95,111,102,115,41,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,92,10,9,123,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,92,10,9,9,104,105,103,104,112,32,102,108,111,97,116,32,115,100,32,61,32,83,72,65,68,79,87,95,68,69,80,84,72,40,115,104,97,100,111,119,95,116,101,120,116,117,114,101,44,32,118,101,99,50,40,109,95,111,102,115,44,32,115,104,41,41,59,32,92,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,43,61,32,115,116,101,112,40,115,122,44,32,115,100,41,59,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,92,10,9,125,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,78,69,65,82,69,83,84,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,80,67,70,51,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,47,61,32,51,46,48,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,80,67,70,53,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,47,61,32,53,46,48,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,80,67,70,55,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,47,61,32,55,46,48,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,80,67,70,57,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,52,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,52,46,48,41,59,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,47,61,32,57,46,48,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,72,65,68,79,87,95,70,73,76,84,69,82,95,80,67,70,49,51,10,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,54,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,53,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,52,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,43,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,50,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,51,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,52,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,53,46,48,41,59,10,9,9,83,72,65,68,79,87,95,84,69,83,84,40,115,117,32,45,32,115,104,97,100,111,119,112,105,120,101,108,95,115,105,122,101,32,42,32,54,46,48,41,59,10,9,9,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,32,47,61,32,49,51,46,48,59,10,10,35,101,110,100,105,102,10,10,9,9,47,47,99,111,108,111,114,32,42,61,32,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,59,10,9,9,99,111,108,111,114,32,61,32,109,105,120,40,114,101,97,108,95,108,105,103,104,116,95,115,104,97,100,111,119,95,99,111,108,111,114,44,32,99,111,108,111,114,44,32,115,104,97,100,111,119,95,97,116,116,101,110,117,97,116,105,111,110,41,59,10,47,47,117,115,101,32,115,104,97,100,111,119,115,10,35,101,110,100,105,102,10,9,125,10,10,47,47,117,115,101,32,108,105,103,104,116,105,110,103,10,35,101,110,100,105,102,10,9,47,47,99,111,108,111,114,46,114,103,98,32,42,61,32,99,111,108,111,114,46,97,59,10,9,102,114,97,103,95,99,111,108,111,114,32,61,32,99,111,108,111,114,59,10,125,10,		0};

		static const int _fragment_code_start=262;
		setup(_conditional_strings,21,_uniform_strings,15,_attribute_pairs,0, _texunit_pairs,6,_ubo_pairs,3,_feedbacks,0,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	}

};

#endif

