/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef SSAO_GLSL_GEN_HGLES3_120
#define SSAO_GLSL_GEN_HGLES3_120


#include "drivers/gles3/shader_gles3.h"


class SsaoShaderGLES3 : public ShaderGLES3 {

	 virtual String get_shader_name() const { return "SsaoShaderGLES3"; }
public:

	enum Conditionals {
		SSAO_QUALITY_HIGH,
		SSAO_QUALITY_LOW,
		ENABLE_RADIUS2,
		USE_ORTHOGONAL_PROJECTION,
	};

	enum Uniforms {
		SCREEN_SIZE,
		CAMERA_Z_FAR,
		CAMERA_Z_NEAR,
		INTENSITY_DIV_R6,
		RADIUS,
		INTENSITY_DIV_R62,
		RADIUS2,
		BIAS,
		PROJ_SCALE,
		PROJ_INFO,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	_FORCE_INLINE_ void set_conditional(Conditionals p_conditional,bool p_enable)  {  _set_conditional(p_conditional,p_enable); }

	#ifdef DEBUG_ENABLED
 	#define _FU if (get_uniform(p_uniform)<0) return; if (!is_version_valid()) return; ERR_FAIL_COND( get_active()!=this ); 

 	#else
 	#define _FU if (get_uniform(p_uniform)<0) return; 

 	#endif
	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Size2i& p_vec2) { _FU GLint vec2[2]={p_vec2.x,p_vec2.y}; glUniform2iv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


                glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


        glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
}

#undef _FU


	virtual void init() {

		static const char* _conditional_strings[]={
			"#define SSAO_QUALITY_HIGH\n",
			"#define SSAO_QUALITY_LOW\n",
			"#define ENABLE_RADIUS2\n",
			"#define USE_ORTHOGONAL_PROJECTION\n",
		};

		static const char* _uniform_strings[]={
			"screen_size",
			"camera_z_far",
			"camera_z_near",
			"intensity_div_r6",
			"radius",
			"intensity_div_r62",
			"radius2",
			"bias",
			"proj_scale",
			"proj_info",
		};

		static AttributePair *_attribute_pairs=NULL;
		static const Feedback* _feedbacks=NULL;
		static TexUnitPair _texunit_pairs[]={
			{"source_depth",0},
			{"source_depth_mipmaps",1},
			{"source_normal",2},
		};

		static UBOPair *_ubo_pairs=NULL;
		static const char _vertex_code[]={
10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,9,103,108,95,80,111,115,105,116,105,111,110,46,122,32,61,32,49,46,48,59,10,125,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,		0};

		static const int _vertex_code_start=2;
		static const char _fragment_code[]={
10,35,100,101,102,105,110,101,32,84,87,79,95,80,73,32,54,46,50,56,51,49,56,53,51,48,55,49,55,57,53,56,54,52,55,54,57,50,53,50,56,54,55,54,54,53,53,57,10,10,35,105,102,100,101,102,32,83,83,65,79,95,81,85,65,76,73,84,89,95,72,73,71,72,10,35,100,101,102,105,110,101,32,78,85,77,95,83,65,77,80,76,69,83,32,40,49,54,41,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,83,83,65,79,95,81,85,65,76,73,84,89,95,76,79,87,10,35,100,101,102,105,110,101,32,78,85,77,95,83,65,77,80,76,69,83,32,40,56,41,10,35,101,110,100,105,102,10,10,35,105,102,32,33,100,101,102,105,110,101,100,40,83,83,65,79,95,81,85,65,76,73,84,89,95,76,79,87,41,32,38,38,32,33,100,101,102,105,110,101,100,40,83,83,65,79,95,81,85,65,76,73,84,89,95,72,73,71,72,41,10,35,100,101,102,105,110,101,32,78,85,77,95,83,65,77,80,76,69,83,32,40,49,50,41,10,35,101,110,100,105,102,10,10,47,47,32,73,102,32,117,115,105,110,103,32,100,101,112,116,104,32,109,105,112,32,108,101,118,101,108,115,44,32,116,104,101,32,108,111,103,32,111,102,32,116,104,101,32,109,97,120,105,109,117,109,32,112,105,120,101,108,32,111,102,102,115,101,116,32,98,101,102,111,114,101,32,119,101,32,110,101,101,100,32,116,111,32,115,119,105,116,99,104,32,116,111,32,97,32,108,111,119,101,114,10,47,47,32,109,105,112,108,101,118,101,108,32,116,111,32,109,97,105,110,116,97,105,110,32,114,101,97,115,111,110,97,98,108,101,32,115,112,97,116,105,97,108,32,108,111,99,97,108,105,116,121,32,105,110,32,116,104,101,32,99,97,99,104,101,10,47,47,32,73,102,32,116,104,105,115,32,110,117,109,98,101,114,32,105,115,32,116,111,111,32,115,109,97,108,108,32,40,60,32,51,41,44,32,116,111,111,32,109,97,110,121,32,116,97,112,115,32,119,105,108,108,32,108,97,110,100,32,105,110,32,116,104,101,32,115,97,109,101,32,112,105,120,101,108,44,32,97,110,100,32,119,101,39,108,108,32,103,101,116,32,98,97,100,32,118,97,114,105,97,110,99,101,32,116,104,97,116,32,109,97,110,105,102,101,115,116,115,32,97,115,32,102,108,97,115,104,105,110,103,46,10,47,47,32,73,102,32,105,116,32,105,115,32,116,111,111,32,104,105,103,104,32,40,62,32,53,41,44,32,119,101,39,108,108,32,103,101,116,32,98,97,100,32,112,101,114,102,111,114,109,97,110,99,101,32,98,101,99,97,117,115,101,32,119,101,39,114,101,32,110,111,116,32,117,115,105,110,103,32,116,104,101,32,77,73,80,32,108,101,118,101,108,115,32,101,102,102,101,99,116,105,118,101,108,121,10,35,100,101,102,105,110,101,32,76,79,71,95,77,65,88,95,79,70,70,83,69,84,32,40,51,41,10,10,47,47,32,84,104,105,115,32,109,117,115,116,32,98,101,32,108,101,115,115,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,32,116,104,101,32,77,65,88,95,77,73,80,95,76,69,86,69,76,32,100,101,102,105,110,101,100,32,105,110,32,83,83,65,79,46,99,112,112,10,35,100,101,102,105,110,101,32,77,65,88,95,77,73,80,95,76,69,86,69,76,32,40,52,41,10,10,47,47,32,84,104,105,115,32,105,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,116,117,114,110,115,32,97,114,111,117,110,100,32,116,104,101,32,99,105,114,99,108,101,32,116,104,97,116,32,116,104,101,32,115,112,105,114,97,108,32,112,97,116,116,101,114,110,32,109,97,107,101,115,46,32,32,84,104,105,115,32,115,104,111,117,108,100,32,98,101,32,112,114,105,109,101,32,116,111,32,112,114,101,118,101,110,116,10,47,47,32,116,97,112,115,32,102,114,111,109,32,108,105,110,105,110,103,32,117,112,46,32,32,84,104,105,115,32,112,97,114,116,105,99,117,108,97,114,32,99,104,111,105,99,101,32,119,97,115,32,116,117,110,101,100,32,102,111,114,32,78,85,77,95,83,65,77,80,76,69,83,32,61,61,32,57,10,10,99,111,110,115,116,32,105,110,116,32,82,79,84,65,84,73,79,78,83,91,93,32,61,32,105,110,116,91,93,40,10,9,9,49,44,32,49,44,32,50,44,32,51,44,32,50,44,32,53,44,32,50,44,32,51,44,32,50,44,10,9,9,51,44,32,51,44,32,53,44,32,53,44,32,51,44,32,52,44,32,55,44,32,53,44,32,53,44,32,55,44,10,9,9,57,44,32,56,44,32,53,44,32,53,44,32,55,44,32,55,44,32,55,44,32,56,44,32,53,44,32,56,44,10,9,9,49,49,44,32,49,50,44,32,55,44,32,49,48,44,32,49,51,44,32,56,44,32,49,49,44,32,56,44,32,55,44,32,49,52,44,10,9,9,49,49,44,32,49,49,44,32,49,51,44,32,49,50,44,32,49,51,44,32,49,57,44,32,49,55,44,32,49,51,44,32,49,49,44,32,49,56,44,10,9,9,49,57,44,32,49,49,44,32,49,49,44,32,49,52,44,32,49,55,44,32,50,49,44,32,49,53,44,32,49,54,44,32,49,55,44,32,49,56,44,10,9,9,49,51,44,32,49,55,44,32,49,49,44,32,49,55,44,32,49,57,44,32,49,56,44,32,50,53,44,32,49,56,44,32,49,57,44,32,49,57,44,10,9,9,50,57,44,32,50,49,44,32,49,57,44,32,50,55,44,32,51,49,44,32,50,57,44,32,50,49,44,32,49,56,44,32,49,55,44,32,50,57,44,10,9,9,51,49,44,32,51,49,44,32,50,51,44,32,49,56,44,32,50,53,44,32,50,54,44,32,50,53,44,32,50,51,44,32,49,57,44,32,51,52,44,10,9,9,49,57,44,32,50,55,44,32,50,49,44,32,50,53,44,32,51,57,44,32,50,57,44,32,49,55,44,32,50,49,44,32,50,55,41,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,47,47,35,100,101,102,105,110,101,32,78,85,77,95,83,80,73,82,65,76,95,84,85,82,78,83,32,40,55,41,10,99,111,110,115,116,32,105,110,116,32,78,85,77,95,83,80,73,82,65,76,95,84,85,82,78,83,32,61,32,82,79,84,65,84,73,79,78,83,91,78,85,77,95,83,65,77,80,76,69,83,32,45,32,49,93,59,10,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,100,101,112,116,104,59,32,47,47,116,101,120,117,110,105,116,58,48,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,117,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,100,101,112,116,104,95,109,105,112,109,97,112,115,59,32,47,47,116,101,120,117,110,105,116,58,49,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,110,111,114,109,97,108,59,32,47,47,116,101,120,117,110,105,116,58,50,10,10,117,110,105,102,111,114,109,32,105,118,101,99,50,32,115,99,114,101,101,110,95,115,105,122,101,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,110,101,97,114,59,10,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,105,110,116,101,110,115,105,116,121,95,100,105,118,95,114,54,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,114,97,100,105,117,115,59,10,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,82,65,68,73,85,83,50,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,105,110,116,101,110,115,105,116,121,95,100,105,118,95,114,54,50,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,114,97,100,105,117,115,50,59,10,35,101,110,100,105,102,10,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,98,105,97,115,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,112,114,111,106,95,115,99,97,108,101,59,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,111,117,116,32,102,108,111,97,116,32,118,105,115,105,98,105,108,105,116,121,59,10,10,117,110,105,102,111,114,109,32,118,101,99,52,32,112,114,111,106,95,105,110,102,111,59,10,10,118,101,99,51,32,114,101,99,111,110,115,116,114,117,99,116,67,83,80,111,115,105,116,105,111,110,40,118,101,99,50,32,83,44,32,102,108,111,97,116,32,122,41,32,123,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,114,101,116,117,114,110,32,118,101,99,51,40,40,83,46,120,121,32,42,32,112,114,111,106,95,105,110,102,111,46,120,121,32,43,32,112,114,111,106,95,105,110,102,111,46,122,119,41,44,32,122,41,59,10,35,101,108,115,101,10,9,114,101,116,117,114,110,32,118,101,99,51,40,40,83,46,120,121,32,42,32,112,114,111,106,95,105,110,102,111,46,120,121,32,43,32,112,114,111,106,95,105,110,102,111,46,122,119,41,32,42,32,122,44,32,122,41,59,10,10,35,101,110,100,105,102,10,125,10,10,118,101,99,51,32,103,101,116,80,111,115,105,116,105,111,110,40,105,118,101,99,50,32,115,115,80,41,32,123,10,9,118,101,99,51,32,80,59,10,9,80,46,122,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,115,115,80,44,32,48,41,46,114,59,10,10,9,80,46,122,32,61,32,80,46,122,32,42,32,50,46,48,32,45,32,49,46,48,59,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,80,46,122,32,61,32,40,40,80,46,122,32,43,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,47,32,50,46,48,59,10,35,101,108,115,101,10,9,80,46,122,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,80,46,122,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,35,101,110,100,105,102,10,9,80,46,122,32,61,32,45,80,46,122,59,10,10,9,47,47,32,79,102,102,115,101,116,32,116,111,32,112,105,120,101,108,32,99,101,110,116,101,114,10,9,80,32,61,32,114,101,99,111,110,115,116,114,117,99,116,67,83,80,111,115,105,116,105,111,110,40,118,101,99,50,40,115,115,80,41,32,43,32,118,101,99,50,40,48,46,53,41,44,32,80,46,122,41,59,10,9,114,101,116,117,114,110,32,80,59,10,125,10,10,47,42,42,32,82,101,99,111,110,115,116,114,117,99,116,115,32,115,99,114,101,101,110,45,115,112,97,99,101,32,117,110,105,116,32,110,111,114,109,97,108,32,102,114,111,109,32,115,99,114,101,101,110,45,115,112,97,99,101,32,112,111,115,105,116,105,111,110,32,42,47,10,118,101,99,51,32,114,101,99,111,110,115,116,114,117,99,116,67,83,70,97,99,101,78,111,114,109,97,108,40,118,101,99,51,32,67,41,32,123,10,9,114,101,116,117,114,110,32,110,111,114,109,97,108,105,122,101,40,99,114,111,115,115,40,100,70,100,121,40,67,41,44,32,100,70,100,120,40,67,41,41,41,59,10,125,10,10,47,42,42,32,82,101,116,117,114,110,115,32,97,32,117,110,105,116,32,118,101,99,116,111,114,32,97,110,100,32,97,32,115,99,114,101,101,110,45,115,112,97,99,101,32,114,97,100,105,117,115,32,102,111,114,32,116,104,101,32,116,97,112,32,111,110,32,97,32,117,110,105,116,32,100,105,115,107,32,40,116,104,101,32,99,97,108,108,101,114,32,115,104,111,117,108,100,32,115,99,97,108,101,32,98,121,32,116,104,101,32,97,99,116,117,97,108,32,100,105,115,107,32,114,97,100,105,117,115,41,32,42,47,10,118,101,99,50,32,116,97,112,76,111,99,97,116,105,111,110,40,105,110,116,32,115,97,109,112,108,101,78,117,109,98,101,114,44,32,102,108,111,97,116,32,115,112,105,110,65,110,103,108,101,44,32,111,117,116,32,102,108,111,97,116,32,115,115,82,41,32,123,10,9,47,47,32,82,97,100,105,117,115,32,114,101,108,97,116,105,118,101,32,116,111,32,115,115,82,10,9,102,108,111,97,116,32,97,108,112,104,97,32,61,32,40,102,108,111,97,116,40,115,97,109,112,108,101,78,117,109,98,101,114,41,32,43,32,48,46,53,41,32,42,32,40,49,46,48,32,47,32,102,108,111,97,116,40,78,85,77,95,83,65,77,80,76,69,83,41,41,59,10,9,102,108,111,97,116,32,97,110,103,108,101,32,61,32,97,108,112,104,97,32,42,32,40,102,108,111,97,116,40,78,85,77,95,83,80,73,82,65,76,95,84,85,82,78,83,41,32,42,32,54,46,50,56,41,32,43,32,115,112,105,110,65,110,103,108,101,59,10,10,9,115,115,82,32,61,32,97,108,112,104,97,59,10,9,114,101,116,117,114,110,32,118,101,99,50,40,99,111,115,40,97,110,103,108,101,41,44,32,115,105,110,40,97,110,103,108,101,41,41,59,10,125,10,10,47,42,42,32,82,101,97,100,32,116,104,101,32,99,97,109,101,114,97,45,115,112,97,99,101,32,112,111,115,105,116,105,111,110,32,111,102,32,116,104,101,32,112,111,105,110,116,32,97,116,32,115,99,114,101,101,110,45,115,112,97,99,101,32,112,105,120,101,108,32,115,115,80,32,43,32,117,110,105,116,79,102,102,115,101,116,32,42,32,115,115,82,46,32,32,65,115,115,117,109,101,115,32,108,101,110,103,116,104,40,117,110,105,116,79,102,102,115,101,116,41,32,61,61,32,49,32,42,47,10,118,101,99,51,32,103,101,116,79,102,102,115,101,116,80,111,115,105,116,105,111,110,40,105,118,101,99,50,32,115,115,67,44,32,118,101,99,50,32,117,110,105,116,79,102,102,115,101,116,44,32,102,108,111,97,116,32,115,115,82,41,32,123,10,9,47,47,32,68,101,114,105,118,97,116,105,111,110,58,10,9,47,47,32,32,109,105,112,76,101,118,101,108,32,61,32,102,108,111,111,114,40,108,111,103,40,115,115,82,32,47,32,77,65,88,95,79,70,70,83,69,84,41,41,59,10,9,105,110,116,32,109,105,112,76,101,118,101,108,32,61,32,99,108,97,109,112,40,105,110,116,40,102,108,111,111,114,40,108,111,103,50,40,115,115,82,41,41,41,32,45,32,76,79,71,95,77,65,88,95,79,70,70,83,69,84,44,32,48,44,32,77,65,88,95,77,73,80,95,76,69,86,69,76,41,59,10,10,9,105,118,101,99,50,32,115,115,80,32,61,32,105,118,101,99,50,40,115,115,82,32,42,32,117,110,105,116,79,102,102,115,101,116,41,32,43,32,115,115,67,59,10,10,9,118,101,99,51,32,80,59,10,10,9,47,47,32,87,101,32,110,101,101,100,32,116,111,32,100,105,118,105,100,101,32,98,121,32,50,94,109,105,112,76,101,118,101,108,32,116,111,32,114,101,97,100,32,116,104,101,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,115,99,97,108,101,100,32,99,111,111,114,100,105,110,97,116,101,32,102,114,111,109,32,97,32,77,73,80,45,109,97,112,46,10,9,47,47,32,77,97,110,117,97,108,108,121,32,99,108,97,109,112,32,116,111,32,116,104,101,32,116,101,120,116,117,114,101,32,115,105,122,101,32,98,101,99,97,117,115,101,32,116,101,120,101,108,70,101,116,99,104,32,98,121,112,97,115,115,101,115,32,116,104,101,32,116,101,120,116,117,114,101,32,117,110,105,116,10,9,105,118,101,99,50,32,109,105,112,80,32,61,32,99,108,97,109,112,40,115,115,80,32,62,62,32,109,105,112,76,101,118,101,108,44,32,105,118,101,99,50,40,48,41,44,32,40,115,99,114,101,101,110,95,115,105,122,101,32,62,62,32,109,105,112,76,101,118,101,108,41,32,45,32,105,118,101,99,50,40,49,41,41,59,10,10,9,105,102,32,40,109,105,112,76,101,118,101,108,32,60,32,49,41,32,123,10,9,9,47,47,114,101,97,100,32,102,114,111,109,32,100,101,112,116,104,32,98,117,102,102,101,114,10,9,9,80,46,122,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,109,105,112,80,44,32,48,41,46,114,59,10,9,9,80,46,122,32,61,32,80,46,122,32,42,32,50,46,48,32,45,32,49,46,48,59,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,9,80,46,122,32,61,32,40,40,80,46,122,32,43,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,47,32,50,46,48,59,10,35,101,108,115,101,10,9,9,80,46,122,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,80,46,122,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,35,101,110,100,105,102,10,9,9,80,46,122,32,61,32,45,80,46,122,59,10,10,9,125,32,101,108,115,101,32,123,10,9,9,47,47,114,101,97,100,32,102,114,111,109,32,109,105,112,109,97,112,115,10,9,9,117,105,110,116,32,100,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,100,101,112,116,104,95,109,105,112,109,97,112,115,44,32,109,105,112,80,44,32,109,105,112,76,101,118,101,108,32,45,32,49,41,46,114,59,10,9,9,80,46,122,32,61,32,45,40,102,108,111,97,116,40,100,41,32,47,32,54,53,53,51,53,46,48,41,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,9,125,10,10,9,47,47,32,79,102,102,115,101,116,32,116,111,32,112,105,120,101,108,32,99,101,110,116,101,114,10,9,80,32,61,32,114,101,99,111,110,115,116,114,117,99,116,67,83,80,111,115,105,116,105,111,110,40,118,101,99,50,40,115,115,80,41,32,43,32,118,101,99,50,40,48,46,53,41,44,32,80,46,122,41,59,10,10,9,114,101,116,117,114,110,32,80,59,10,125,10,10,47,42,42,32,67,111,109,112,117,116,101,32,116,104,101,32,111,99,99,108,117,115,105,111,110,32,100,117,101,32,116,111,32,115,97,109,112,108,101,32,119,105,116,104,32,105,110,100,101,120,32,92,97,32,105,32,97,98,111,117,116,32,116,104,101,32,112,105,120,101,108,32,97,116,32,92,97,32,115,115,67,32,116,104,97,116,32,99,111,114,114,101,115,112,111,110,100,115,10,9,116,111,32,99,97,109,101,114,97,45,115,112,97,99,101,32,112,111,105,110,116,32,92,97,32,67,32,119,105,116,104,32,117,110,105,116,32,110,111,114,109,97,108,32,92,97,32,110,95,67,44,32,117,115,105,110,103,32,109,97,120,105,109,117,109,32,115,99,114,101,101,110,45,115,112,97,99,101,32,115,97,109,112,108,105,110,103,32,114,97,100,105,117,115,32,92,97,32,115,115,68,105,115,107,82,97,100,105,117,115,10,10,9,78,111,116,101,32,116,104,97,116,32,117,110,105,116,115,32,111,102,32,72,40,41,32,105,110,32,116,104,101,32,72,80,71,49,50,32,112,97,112,101,114,32,97,114,101,32,109,101,116,101,114,115,44,32,110,111,116,10,9,117,110,105,116,108,101,115,115,46,32,32,84,104,101,32,119,104,111,108,101,32,102,97,108,108,111,102,102,47,115,97,109,112,108,105,110,103,32,102,117,110,99,116,105,111,110,32,105,115,32,116,104,101,114,101,102,111,114,101,10,9,117,110,105,116,108,101,115,115,46,32,32,73,110,32,116,104,105,115,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,44,32,119,101,32,102,97,99,116,111,114,32,111,117,116,32,40,57,32,47,32,114,97,100,105,117,115,41,46,10,10,9,70,111,117,114,32,118,101,114,115,105,111,110,115,32,111,102,32,116,104,101,32,102,97,108,108,111,102,102,32,102,117,110,99,116,105,111,110,32,97,114,101,32,105,109,112,108,101,109,101,110,116,101,100,32,98,101,108,111,119,10,42,47,10,102,108,111,97,116,32,115,97,109,112,108,101,65,79,40,105,110,32,105,118,101,99,50,32,115,115,67,44,32,105,110,32,118,101,99,51,32,67,44,32,105,110,32,118,101,99,51,32,110,95,67,44,32,105,110,32,102,108,111,97,116,32,115,115,68,105,115,107,82,97,100,105,117,115,44,32,105,110,32,102,108,111,97,116,32,112,95,114,97,100,105,117,115,44,32,105,110,32,105,110,116,32,116,97,112,73,110,100,101,120,44,32,105,110,32,102,108,111,97,116,32,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,41,32,123,10,9,47,47,32,79,102,102,115,101,116,32,111,110,32,116,104,101,32,117,110,105,116,32,100,105,115,107,44,32,115,112,117,110,32,102,111,114,32,116,104,105,115,32,112,105,120,101,108,10,9,102,108,111,97,116,32,115,115,82,59,10,9,118,101,99,50,32,117,110,105,116,79,102,102,115,101,116,32,61,32,116,97,112,76,111,99,97,116,105,111,110,40,116,97,112,73,110,100,101,120,44,32,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,44,32,115,115,82,41,59,10,9,115,115,82,32,42,61,32,115,115,68,105,115,107,82,97,100,105,117,115,59,10,10,9,47,47,32,84,104,101,32,111,99,99,108,117,100,105,110,103,32,112,111,105,110,116,32,105,110,32,99,97,109,101,114,97,32,115,112,97,99,101,10,9,118,101,99,51,32,81,32,61,32,103,101,116,79,102,102,115,101,116,80,111,115,105,116,105,111,110,40,115,115,67,44,32,117,110,105,116,79,102,102,115,101,116,44,32,115,115,82,41,59,10,10,9,118,101,99,51,32,118,32,61,32,81,32,45,32,67,59,10,10,9,102,108,111,97,116,32,118,118,32,61,32,100,111,116,40,118,44,32,118,41,59,10,9,102,108,111,97,116,32,118,110,32,61,32,100,111,116,40,118,44,32,110,95,67,41,59,10,10,9,99,111,110,115,116,32,102,108,111,97,116,32,101,112,115,105,108,111,110,32,61,32,48,46,48,49,59,10,9,102,108,111,97,116,32,114,97,100,105,117,115,50,32,61,32,112,95,114,97,100,105,117,115,32,42,32,112,95,114,97,100,105,117,115,59,10,10,9,47,47,32,65,58,32,70,114,111,109,32,116,104,101,32,72,80,71,49,50,32,112,97,112,101,114,10,9,47,47,32,78,111,116,101,32,108,97,114,103,101,32,101,112,115,105,108,111,110,32,116,111,32,97,118,111,105,100,32,111,118,101,114,100,97,114,107,101,110,105,110,103,32,119,105,116,104,105,110,32,99,114,97,99,107,115,10,9,47,47,114,101,116,117,114,110,32,102,108,111,97,116,40,118,118,32,60,32,114,97,100,105,117,115,50,41,32,42,32,109,97,120,40,40,118,110,32,45,32,98,105,97,115,41,32,47,32,40,101,112,115,105,108,111,110,32,43,32,118,118,41,44,32,48,46,48,41,32,42,32,114,97,100,105,117,115,50,32,42,32,48,46,54,59,10,10,9,47,47,32,66,58,32,83,109,111,111,116,104,101,114,32,116,114,97,110,115,105,116,105,111,110,32,116,111,32,122,101,114,111,32,40,108,111,119,101,114,115,32,99,111,110,116,114,97,115,116,44,32,115,109,111,111,116,104,105,110,103,32,111,117,116,32,99,111,114,110,101,114,115,41,46,32,91,82,101,99,111,109,109,101,110,100,101,100,93,10,9,102,108,111,97,116,32,102,32,61,32,109,97,120,40,114,97,100,105,117,115,50,32,45,32,118,118,44,32,48,46,48,41,59,10,9,114,101,116,117,114,110,32,102,32,42,32,102,32,42,32,102,32,42,32,109,97,120,40,40,118,110,32,45,32,98,105,97,115,41,32,47,32,40,101,112,115,105,108,111,110,32,43,32,118,118,41,44,32,48,46,48,41,59,10,10,9,47,47,32,67,58,32,77,101,100,105,117,109,32,99,111,110,116,114,97,115,116,32,40,119,104,105,99,104,32,108,111,111,107,115,32,98,101,116,116,101,114,32,97,116,32,104,105,103,104,32,114,97,100,105,105,41,44,32,110,111,32,100,105,118,105,115,105,111,110,46,32,32,78,111,116,101,32,116,104,97,116,32,116,104,101,10,9,47,47,32,99,111,110,116,114,105,98,117,116,105,111,110,32,115,116,105,108,108,32,102,97,108,108,115,32,111,102,102,32,119,105,116,104,32,114,97,100,105,117,115,94,50,44,32,98,117,116,32,119,101,39,118,101,32,97,100,106,117,115,116,101,100,32,116,104,101,32,114,97,116,101,32,105,110,32,97,32,119,97,121,32,116,104,97,116,32,105,115,10,9,47,47,32,109,111,114,101,32,99,111,109,112,117,116,97,116,105,111,110,97,108,108,121,32,101,102,102,105,99,105,101,110,116,32,97,110,100,32,104,97,112,112,101,110,115,32,116,111,32,98,101,32,97,101,115,116,104,101,116,105,99,97,108,108,121,32,112,108,101,97,115,105,110,103,46,10,9,47,47,32,114,101,116,117,114,110,32,52,46,48,32,42,32,109,97,120,40,49,46,48,32,45,32,118,118,32,42,32,105,110,118,82,97,100,105,117,115,50,44,32,48,46,48,41,32,42,32,109,97,120,40,118,110,32,45,32,98,105,97,115,44,32,48,46,48,41,59,10,10,9,47,47,32,68,58,32,76,111,119,32,99,111,110,116,114,97,115,116,44,32,110,111,32,100,105,118,105,115,105,111,110,32,111,112,101,114,97,116,105,111,110,10,9,47,47,32,114,101,116,117,114,110,32,50,46,48,32,42,32,102,108,111,97,116,40,118,118,32,60,32,114,97,100,105,117,115,32,42,32,114,97,100,105,117,115,41,32,42,32,109,97,120,40,118,110,32,45,32,98,105,97,115,44,32,48,46,48,41,59,10,125,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,9,47,47,32,80,105,120,101,108,32,98,101,105,110,103,32,115,104,97,100,101,100,10,9,105,118,101,99,50,32,115,115,67,32,61,32,105,118,101,99,50,40,103,108,95,70,114,97,103,67,111,111,114,100,46,120,121,41,59,10,10,9,47,47,32,87,111,114,108,100,32,115,112,97,99,101,32,112,111,105,110,116,32,98,101,105,110,103,32,115,104,97,100,101,100,10,9,118,101,99,51,32,67,32,61,32,103,101,116,80,111,115,105,116,105,111,110,40,115,115,67,41,59,10,10,9,47,42,10,9,105,102,32,40,67,46,122,32,60,61,32,45,99,97,109,101,114,97,95,122,95,102,97,114,32,42,32,48,46,57,57,57,41,32,123,10,9,9,47,47,32,87,101,39,114,101,32,111,110,32,116,104,101,32,115,107,121,98,111,120,10,9,9,118,105,115,105,98,105,108,105,116,121,61,49,46,48,59,10,9,9,114,101,116,117,114,110,59,10,9,125,10,9,42,47,10,10,9,47,47,118,105,115,105,98,105,108,105,116,121,32,61,32,45,67,46,122,32,47,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,9,47,47,114,101,116,117,114,110,59,10,35,105,102,32,48,10,9,118,101,99,51,32,110,95,67,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,110,111,114,109,97,108,44,32,115,115,67,44,32,48,41,46,114,103,98,32,42,32,50,46,48,32,45,32,49,46,48,59,10,35,101,108,115,101,10,9,118,101,99,51,32,110,95,67,32,61,32,114,101,99,111,110,115,116,114,117,99,116,67,83,70,97,99,101,78,111,114,109,97,108,40,67,41,59,10,9,110,95,67,32,61,32,45,110,95,67,59,10,35,101,110,100,105,102,10,10,9,47,47,32,72,97,115,104,32,102,117,110,99,116,105,111,110,32,117,115,101,100,32,105,110,32,116,104,101,32,72,80,71,49,50,32,65,108,99,104,101,109,121,65,79,32,112,97,112,101,114,10,9,102,108,111,97,116,32,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,32,61,32,109,111,100,40,102,108,111,97,116,40,40,51,32,42,32,115,115,67,46,120,32,94,32,115,115,67,46,121,32,43,32,115,115,67,46,120,32,42,32,115,115,67,46,121,41,32,42,32,49,48,41,44,32,84,87,79,95,80,73,41,59,10,10,9,47,47,32,82,101,99,111,110,115,116,114,117,99,116,32,110,111,114,109,97,108,115,32,102,114,111,109,32,112,111,115,105,116,105,111,110,115,46,32,84,104,101,115,101,32,119,105,108,108,32,108,101,97,100,32,116,111,32,49,45,112,105,120,101,108,32,98,108,97,99,107,32,108,105,110,101,115,10,9,47,47,32,97,116,32,100,101,112,116,104,32,100,105,115,99,111,110,116,105,110,117,105,116,105,101,115,44,32,104,111,119,101,118,101,114,32,116,104,101,32,98,108,117,114,32,119,105,108,108,32,119,105,112,101,32,116,104,111,115,101,32,111,117,116,32,115,111,32,116,104,101,121,32,97,114,101,32,110,111,116,32,118,105,115,105,98,108,101,10,9,47,47,32,105,110,32,116,104,101,32,102,105,110,97,108,32,105,109,97,103,101,46,10,10,9,47,47,32,67,104,111,111,115,101,32,116,104,101,32,115,99,114,101,101,110,45,115,112,97,99,101,32,115,97,109,112,108,101,32,114,97,100,105,117,115,10,9,47,47,32,112,114,111,112,111,114,116,105,111,110,97,108,32,116,111,32,116,104,101,32,112,114,111,106,101,99,116,101,100,32,97,114,101,97,32,111,102,32,116,104,101,32,115,112,104,101,114,101,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,102,108,111,97,116,32,115,115,68,105,115,107,82,97,100,105,117,115,32,61,32,45,112,114,111,106,95,115,99,97,108,101,32,42,32,114,97,100,105,117,115,59,10,35,101,108,115,101,10,9,102,108,111,97,116,32,115,115,68,105,115,107,82,97,100,105,117,115,32,61,32,45,112,114,111,106,95,115,99,97,108,101,32,42,32,114,97,100,105,117,115,32,47,32,67,46,122,59,10,35,101,110,100,105,102,10,9,102,108,111,97,116,32,115,117,109,32,61,32,48,46,48,59,10,9,102,111,114,32,40,105,110,116,32,105,32,61,32,48,59,32,105,32,60,32,78,85,77,95,83,65,77,80,76,69,83,59,32,43,43,105,41,32,123,10,9,9,115,117,109,32,43,61,32,115,97,109,112,108,101,65,79,40,115,115,67,44,32,67,44,32,110,95,67,44,32,115,115,68,105,115,107,82,97,100,105,117,115,44,32,114,97,100,105,117,115,44,32,105,44,32,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,41,59,10,9,125,10,10,9,102,108,111,97,116,32,65,32,61,32,109,97,120,40,48,46,48,44,32,49,46,48,32,45,32,115,117,109,32,42,32,105,110,116,101,110,115,105,116,121,95,100,105,118,95,114,54,32,42,32,40,53,46,48,32,47,32,102,108,111,97,116,40,78,85,77,95,83,65,77,80,76,69,83,41,41,41,59,10,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,82,65,68,73,85,83,50,10,10,9,47,47,103,111,32,97,103,97,105,110,32,102,111,114,32,114,97,100,105,117,115,50,10,9,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,32,61,32,109,111,100,40,102,108,111,97,116,40,40,53,32,42,32,115,115,67,46,120,32,94,32,115,115,67,46,121,32,43,32,115,115,67,46,120,32,42,32,115,115,67,46,121,41,32,42,32,49,49,41,44,32,84,87,79,95,80,73,41,59,10,10,9,47,47,32,82,101,99,111,110,115,116,114,117,99,116,32,110,111,114,109,97,108,115,32,102,114,111,109,32,112,111,115,105,116,105,111,110,115,46,32,84,104,101,115,101,32,119,105,108,108,32,108,101,97,100,32,116,111,32,49,45,112,105,120,101,108,32,98,108,97,99,107,32,108,105,110,101,115,10,9,47,47,32,97,116,32,100,101,112,116,104,32,100,105,115,99,111,110,116,105,110,117,105,116,105,101,115,44,32,104,111,119,101,118,101,114,32,116,104,101,32,98,108,117,114,32,119,105,108,108,32,119,105,112,101,32,116,104,111,115,101,32,111,117,116,32,115,111,32,116,104,101,121,32,97,114,101,32,110,111,116,32,118,105,115,105,98,108,101,10,9,47,47,32,105,110,32,116,104,101,32,102,105,110,97,108,32,105,109,97,103,101,46,10,10,9,47,47,32,67,104,111,111,115,101,32,116,104,101,32,115,99,114,101,101,110,45,115,112,97,99,101,32,115,97,109,112,108,101,32,114,97,100,105,117,115,10,9,47,47,32,112,114,111,112,111,114,116,105,111,110,97,108,32,116,111,32,116,104,101,32,112,114,111,106,101,99,116,101,100,32,97,114,101,97,32,111,102,32,116,104,101,32,115,112,104,101,114,101,10,9,115,115,68,105,115,107,82,97,100,105,117,115,32,61,32,45,112,114,111,106,95,115,99,97,108,101,32,42,32,114,97,100,105,117,115,50,32,47,32,67,46,122,59,10,10,9,115,117,109,32,61,32,48,46,48,59,10,9,102,111,114,32,40,105,110,116,32,105,32,61,32,48,59,32,105,32,60,32,78,85,77,95,83,65,77,80,76,69,83,59,32,43,43,105,41,32,123,10,9,9,115,117,109,32,43,61,32,115,97,109,112,108,101,65,79,40,115,115,67,44,32,67,44,32,110,95,67,44,32,115,115,68,105,115,107,82,97,100,105,117,115,44,32,114,97,100,105,117,115,50,44,32,105,44,32,114,97,110,100,111,109,80,97,116,116,101,114,110,82,111,116,97,116,105,111,110,65,110,103,108,101,41,59,10,9,125,10,10,9,65,32,61,32,109,105,110,40,65,44,32,109,97,120,40,48,46,48,44,32,49,46,48,32,45,32,115,117,109,32,42,32,105,110,116,101,110,115,105,116,121,95,100,105,118,95,114,54,50,32,42,32,40,53,46,48,32,47,32,102,108,111,97,116,40,78,85,77,95,83,65,77,80,76,69,83,41,41,41,41,59,10,35,101,110,100,105,102,10,9,47,47,32,66,105,108,97,116,101,114,97,108,32,98,111,120,45,102,105,108,116,101,114,32,111,118,101,114,32,97,32,113,117,97,100,32,102,111,114,32,102,114,101,101,44,32,114,101,115,112,101,99,116,105,110,103,32,100,101,112,116,104,32,101,100,103,101,115,10,9,47,47,32,40,116,104,101,32,100,105,102,102,101,114,101,110,99,101,32,116,104,97,116,32,116,104,105,115,32,109,97,107,101,115,32,105,115,32,115,117,98,116,108,101,41,10,9,105,102,32,40,97,98,115,40,100,70,100,120,40,67,46,122,41,41,32,60,32,48,46,48,50,41,32,123,10,9,9,65,32,45,61,32,100,70,100,120,40,65,41,32,42,32,40,102,108,111,97,116,40,115,115,67,46,120,32,38,32,49,41,32,45,32,48,46,53,41,59,10,9,125,10,9,105,102,32,40,97,98,115,40,100,70,100,121,40,67,46,122,41,41,32,60,32,48,46,48,50,41,32,123,10,9,9,65,32,45,61,32,100,70,100,121,40,65,41,32,42,32,40,102,108,111,97,116,40,115,115,67,46,121,32,38,32,49,41,32,45,32,48,46,53,41,59,10,9,125,10,10,9,118,105,115,105,98,105,108,105,116,121,32,61,32,65,59,10,125,10,		0};

		static const int _fragment_code_start=14;
		setup(_conditional_strings,4,_uniform_strings,10,_attribute_pairs,0, _texunit_pairs,3,_ubo_pairs,0,_feedbacks,0,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	}

};

#endif

