/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef SSAO_BLUR_GLSL_GEN_HGLES3_120
#define SSAO_BLUR_GLSL_GEN_HGLES3_120


#include "drivers/gles3/shader_gles3.h"


class SsaoBlurShaderGLES3 : public ShaderGLES3 {

	 virtual String get_shader_name() const { return "SsaoBlurShaderGLES3"; }
public:

	enum Uniforms {
		EDGE_SHARPNESS,
		FILTER_SCALE,
		AXIS,
		CAMERA_Z_FAR,
		CAMERA_Z_NEAR,
		SCREEN_SIZE,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	#ifdef DEBUG_ENABLED
 	#define _FU if (get_uniform(p_uniform)<0) return; if (!is_version_valid()) return; ERR_FAIL_COND( get_active()!=this ); 

 	#else
 	#define _FU if (get_uniform(p_uniform)<0) return; 

 	#endif
	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Size2i& p_vec2) { _FU GLint vec2[2]={p_vec2.x,p_vec2.y}; glUniform2iv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


                glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


        glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
}

#undef _FU


	virtual void init() {

		static const char **_conditional_strings=NULL;
		static const char* _uniform_strings[]={
			"edge_sharpness",
			"filter_scale",
			"axis",
			"camera_z_far",
			"camera_z_near",
			"screen_size",
		};

		static AttributePair *_attribute_pairs=NULL;
		static const Feedback* _feedbacks=NULL;
		static TexUnitPair _texunit_pairs[]={
			{"source_ssao",0},
			{"source_depth",1},
			{"source_normal",3},
		};

		static UBOPair *_ubo_pairs=NULL;
		static const char _vertex_code[]={
10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,9,103,108,95,80,111,115,105,116,105,111,110,46,122,32,61,32,49,46,48,59,10,125,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,		0};

		static const int _vertex_code_start=2;
		static const char _fragment_code[]={
10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,115,115,97,111,59,32,47,47,116,101,120,117,110,105,116,58,48,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,100,101,112,116,104,59,32,47,47,116,101,120,117,110,105,116,58,49,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,110,111,114,109,97,108,59,32,47,47,116,101,120,117,110,105,116,58,51,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,111,117,116,32,102,108,111,97,116,32,118,105,115,105,98,105,108,105,116,121,59,10,10,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,10,47,47,32,84,117,110,97,98,108,101,32,80,97,114,97,109,101,116,101,114,115,58,10,10,47,42,42,32,73,110,99,114,101,97,115,101,32,116,111,32,109,97,107,101,32,100,101,112,116,104,32,101,100,103,101,115,32,99,114,105,115,112,101,114,46,32,68,101,99,114,101,97,115,101,32,116,111,32,114,101,100,117,99,101,32,102,108,105,99,107,101,114,46,32,42,47,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,101,100,103,101,95,115,104,97,114,112,110,101,115,115,59,10,10,47,42,42,32,83,116,101,112,32,105,110,32,50,45,112,105,120,101,108,32,105,110,116,101,114,118,97,108,115,32,115,105,110,99,101,32,119,101,32,97,108,114,101,97,100,121,32,98,108,117,114,114,101,100,32,97,103,97,105,110,115,116,32,110,101,105,103,104,98,111,114,115,32,105,110,32,116,104,101,10,9,102,105,114,115,116,32,65,79,32,112,97,115,115,46,32,32,84,104,105,115,32,99,111,110,115,116,97,110,116,32,99,97,110,32,98,101,32,105,110,99,114,101,97,115,101,100,32,119,104,105,108,101,32,82,32,100,101,99,114,101,97,115,101,115,32,116,111,32,105,109,112,114,111,118,101,10,9,112,101,114,102,111,114,109,97,110,99,101,32,97,116,32,116,104,101,32,101,120,112,101,110,115,101,32,111,102,32,115,111,109,101,32,100,105,116,104,101,114,105,110,103,32,97,114,116,105,102,97,99,116,115,46,10,10,9,77,111,114,103,97,110,32,102,111,117,110,100,32,116,104,97,116,32,97,32,115,99,97,108,101,32,111,102,32,51,32,108,101,102,116,32,97,32,49,45,112,105,120,101,108,32,99,104,101,99,107,101,114,98,111,97,114,100,32,103,114,105,100,32,116,104,97,116,32,119,97,115,10,9,117,110,111,98,106,101,99,116,105,111,110,97,98,108,101,32,97,102,116,101,114,32,115,104,97,100,105,110,103,32,119,97,115,32,97,112,112,108,105,101,100,32,98,117,116,32,101,108,105,109,105,110,97,116,101,100,32,109,111,115,116,32,116,101,109,112,111,114,97,108,32,105,110,99,111,104,101,114,101,110,99,101,10,9,102,114,111,109,32,117,115,105,110,103,32,115,109,97,108,108,32,110,117,109,98,101,114,115,32,111,102,32,115,97,109,112,108,101,32,116,97,112,115,46,10,9,42,47,10,10,117,110,105,102,111,114,109,32,105,110,116,32,102,105,108,116,101,114,95,115,99,97,108,101,59,10,10,47,42,42,32,70,105,108,116,101,114,32,114,97,100,105,117,115,32,105,110,32,112,105,120,101,108,115,46,32,84,104,105,115,32,119,105,108,108,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,83,67,65,76,69,46,32,42,47,10,35,100,101,102,105,110,101,32,82,32,40,52,41,10,10,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,10,10,47,47,32,71,97,117,115,115,105,97,110,32,99,111,101,102,102,105,99,105,101,110,116,115,10,99,111,110,115,116,32,102,108,111,97,116,32,103,97,117,115,115,105,97,110,91,82,32,43,32,49,93,32,61,10,9,9,47,47,102,108,111,97,116,91,93,40,48,46,51,53,54,54,52,50,44,32,48,46,50,51,57,52,48,48,44,32,48,46,48,55,50,52,49,48,44,32,48,46,48,48,57,56,54,57,41,59,10,9,9,47,47,102,108,111,97,116,91,93,40,48,46,51,57,56,57,52,51,44,32,48,46,50,52,49,57,55,49,44,32,48,46,48,53,51,57,57,49,44,32,48,46,48,48,52,52,51,50,44,32,48,46,48,48,48,49,51,52,41,59,32,32,47,47,32,115,116,100,100,101,118,32,61,32,49,46,48,10,9,9,102,108,111,97,116,91,93,40,48,46,49,53,51,49,55,48,44,32,48,46,49,52,52,56,57,51,44,32,48,46,49,50,50,54,52,57,44,32,48,46,48,57,50,57,48,50,44,32,48,46,48,54,50,57,55,48,41,59,32,47,47,32,115,116,100,100,101,118,32,61,32,50,46,48,10,47,47,102,108,111,97,116,91,93,40,48,46,49,49,49,50,50,48,44,32,48,46,49,48,55,55,57,56,44,32,48,46,48,57,56,49,53,49,44,32,48,46,48,56,51,57,53,51,44,32,48,46,48,54,55,52,53,56,44,32,48,46,48,53,48,57,50,48,44,32,48,46,48,51,54,49,48,56,41,59,32,47,47,32,115,116,100,100,101,118,32,61,32,51,46,48,10,10,47,42,42,32,40,49,44,32,48,41,32,111,114,32,40,48,44,32,49,41,32,42,47,10,117,110,105,102,111,114,109,32,105,118,101,99,50,32,97,120,105,115,59,10,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,110,101,97,114,59,10,10,117,110,105,102,111,114,109,32,105,118,101,99,50,32,115,99,114,101,101,110,95,115,105,122,101,59,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,105,118,101,99,50,32,115,115,67,32,61,32,105,118,101,99,50,40,103,108,95,70,114,97,103,67,111,111,114,100,46,120,121,41,59,10,10,9,102,108,111,97,116,32,100,101,112,116,104,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,115,115,67,44,32,48,41,46,114,59,10,9,47,47,118,101,99,51,32,110,111,114,109,97,108,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,110,111,114,109,97,108,44,32,115,115,67,44,32,48,41,46,114,103,98,32,42,32,50,46,48,32,45,32,49,46,48,59,10,10,9,100,101,112,116,104,32,61,32,100,101,112,116,104,32,42,32,50,46,48,32,45,32,49,46,48,59,10,9,100,101,112,116,104,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,100,101,112,116,104,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,10,9,102,108,111,97,116,32,100,101,112,116,104,95,100,105,118,105,100,101,32,61,32,49,46,48,32,47,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,10,9,47,47,100,101,112,116,104,32,42,61,32,100,101,112,116,104,95,100,105,118,105,100,101,59,10,10,9,47,42,10,9,105,102,32,40,100,101,112,116,104,32,62,32,99,97,109,101,114,97,95,122,95,102,97,114,32,42,32,48,46,57,57,57,41,32,123,10,9,9,100,105,115,99,97,114,100,59,32,47,47,115,107,121,98,111,120,10,9,125,10,9,42,47,10,10,9,102,108,111,97,116,32,115,117,109,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,115,115,97,111,44,32,115,115,67,44,32,48,41,46,114,59,10,10,9,47,47,32,66,97,115,101,32,119,101,105,103,104,116,32,102,111,114,32,100,101,112,116,104,32,102,97,108,108,111,102,102,46,32,32,73,110,99,114,101,97,115,101,32,116,104,105,115,32,102,111,114,32,109,111,114,101,32,98,108,117,114,114,105,110,101,115,115,44,10,9,47,47,32,100,101,99,114,101,97,115,101,32,105,116,32,102,111,114,32,98,101,116,116,101,114,32,101,100,103,101,32,100,105,115,99,114,105,109,105,110,97,116,105,111,110,10,9,102,108,111,97,116,32,66,65,83,69,32,61,32,103,97,117,115,115,105,97,110,91,48,93,59,10,9,102,108,111,97,116,32,116,111,116,97,108,87,101,105,103,104,116,32,61,32,66,65,83,69,59,10,9,115,117,109,32,42,61,32,116,111,116,97,108,87,101,105,103,104,116,59,10,10,9,105,118,101,99,50,32,99,108,97,109,112,95,108,105,109,105,116,32,61,32,115,99,114,101,101,110,95,115,105,122,101,32,45,32,105,118,101,99,50,40,49,41,59,10,10,9,102,111,114,32,40,105,110,116,32,114,32,61,32,45,82,59,32,114,32,60,61,32,82,59,32,43,43,114,41,32,123,10,9,9,47,47,32,87,101,32,97,108,114,101,97,100,121,32,104,97,110,100,108,101,100,32,116,104,101,32,122,101,114,111,32,99,97,115,101,32,97,98,111,118,101,46,32,32,84,104,105,115,32,108,111,111,112,32,115,104,111,117,108,100,32,98,101,32,117,110,114,111,108,108,101,100,32,97,110,100,32,116,104,101,32,115,116,97,116,105,99,32,98,114,97,110,99,104,32,111,112,116,105,109,105,122,101,100,32,111,117,116,44,10,9,9,47,47,32,115,111,32,116,104,101,32,73,70,32,115,116,97,116,101,109,101,110,116,32,104,97,115,32,110,111,32,114,117,110,116,105,109,101,32,99,111,115,116,10,9,9,105,102,32,40,114,32,33,61,32,48,41,32,123,10,10,9,9,9,105,118,101,99,50,32,112,112,111,115,32,61,32,115,115,67,32,43,32,97,120,105,115,32,42,32,40,114,32,42,32,102,105,108,116,101,114,95,115,99,97,108,101,41,59,10,9,9,9,102,108,111,97,116,32,118,97,108,117,101,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,115,115,97,111,44,32,99,108,97,109,112,40,112,112,111,115,44,32,105,118,101,99,50,40,48,41,44,32,99,108,97,109,112,95,108,105,109,105,116,41,44,32,48,41,46,114,59,10,9,9,9,105,118,101,99,50,32,114,112,111,115,32,61,32,99,108,97,109,112,40,112,112,111,115,44,32,105,118,101,99,50,40,48,41,44,32,99,108,97,109,112,95,108,105,109,105,116,41,59,10,9,9,9,102,108,111,97,116,32,116,101,109,112,95,100,101,112,116,104,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,114,112,111,115,44,32,48,41,46,114,59,10,9,9,9,47,47,118,101,99,51,32,116,101,109,112,95,110,111,114,109,97,108,32,61,32,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,110,111,114,109,97,108,44,32,114,112,111,115,44,32,48,41,46,114,103,98,32,42,32,50,46,48,32,45,32,49,46,48,59,10,10,9,9,9,116,101,109,112,95,100,101,112,116,104,32,61,32,116,101,109,112,95,100,101,112,116,104,32,42,32,50,46,48,32,45,32,49,46,48,59,10,9,9,9,116,101,109,112,95,100,101,112,116,104,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,116,101,109,112,95,100,101,112,116,104,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,9,9,9,47,47,116,101,109,112,95,100,101,112,116,104,32,42,61,32,100,101,112,116,104,95,100,105,118,105,100,101,59,10,10,9,9,9,47,47,32,115,112,97,116,105,97,108,32,100,111,109,97,105,110,58,32,111,102,102,115,101,116,32,103,97,117,115,115,105,97,110,32,116,97,112,10,9,9,9,102,108,111,97,116,32,119,101,105,103,104,116,32,61,32,48,46,51,32,43,32,103,97,117,115,115,105,97,110,91,97,98,115,40,114,41,93,59,10,9,9,9,47,47,119,101,105,103,104,116,32,42,61,32,109,97,120,40,48,46,48,44,32,100,111,116,40,116,101,109,112,95,110,111,114,109,97,108,44,32,110,111,114,109,97,108,41,41,59,10,10,9,9,9,47,47,32,114,97,110,103,101,32,100,111,109,97,105,110,32,40,116,104,101,32,34,98,105,108,97,116,101,114,97,108,34,32,119,101,105,103,104,116,41,46,32,65,115,32,100,101,112,116,104,32,100,105,102,102,101,114,101,110,99,101,32,105,110,99,114,101,97,115,101,115,44,32,100,101,99,114,101,97,115,101,32,119,101,105,103,104,116,46,10,9,9,9,119,101,105,103,104,116,32,42,61,32,109,97,120,40,48,46,48,44,32,49,46,48,32,45,32,101,100,103,101,95,115,104,97,114,112,110,101,115,115,32,42,32,97,98,115,40,116,101,109,112,95,100,101,112,116,104,32,45,32,100,101,112,116,104,41,41,59,10,10,9,9,9,115,117,109,32,43,61,32,118,97,108,117,101,32,42,32,119,101,105,103,104,116,59,10,9,9,9,116,111,116,97,108,87,101,105,103,104,116,32,43,61,32,119,101,105,103,104,116,59,10,9,9,125,10,9,125,10,10,9,99,111,110,115,116,32,102,108,111,97,116,32,101,112,115,105,108,111,110,32,61,32,48,46,48,48,48,49,59,10,9,118,105,115,105,98,105,108,105,116,121,32,61,32,115,117,109,32,47,32,40,116,111,116,97,108,87,101,105,103,104,116,32,43,32,101,112,115,105,108,111,110,41,59,10,125,10,		0};

		static const int _fragment_code_start=14;
		setup(_conditional_strings,0,_uniform_strings,6,_attribute_pairs,0, _texunit_pairs,3,_ubo_pairs,0,_feedbacks,0,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	}

};

#endif

