/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef SUBSURF_SCATTERING_GLSL_GEN_HGLES3_120
#define SUBSURF_SCATTERING_GLSL_GEN_HGLES3_120


#include "drivers/gles3/shader_gles3.h"


class SubsurfScatteringShaderGLES3 : public ShaderGLES3 {

	 virtual String get_shader_name() const { return "SubsurfScatteringShaderGLES3"; }
public:

	enum Conditionals {
		USE_25_SAMPLES,
		USE_17_SAMPLES,
		USE_11_SAMPLES,
		USE_ORTHOGONAL_PROJECTION,
		ENABLE_STRENGTH_WEIGHTING,
		ENABLE_FOLLOW_SURFACE,
	};

	enum Uniforms {
		MAX_RADIUS,
		CAMERA_Z_FAR,
		CAMERA_Z_NEAR,
		UNIT_SIZE,
		DIR,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	_FORCE_INLINE_ void set_conditional(Conditionals p_conditional,bool p_enable)  {  _set_conditional(p_conditional,p_enable); }

	#ifdef DEBUG_ENABLED
 	#define _FU if (get_uniform(p_uniform)<0) return; if (!is_version_valid()) return; ERR_FAIL_COND( get_active()!=this ); 

 	#else
 	#define _FU if (get_uniform(p_uniform)<0) return; 

 	#endif
	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Size2i& p_vec2) { _FU GLint vec2[2]={p_vec2.x,p_vec2.y}; glUniform2iv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


                glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


        glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
}

#undef _FU


	virtual void init() {

		static const char* _conditional_strings[]={
			"#define USE_25_SAMPLES\n",
			"#define USE_17_SAMPLES\n",
			"#define USE_11_SAMPLES\n",
			"#define USE_ORTHOGONAL_PROJECTION\n",
			"#define ENABLE_STRENGTH_WEIGHTING\n",
			"#define ENABLE_FOLLOW_SURFACE\n",
		};

		static const char* _uniform_strings[]={
			"max_radius",
			"camera_z_far",
			"camera_z_near",
			"unit_size",
			"dir",
		};

		static AttributePair *_attribute_pairs=NULL;
		static const Feedback* _feedbacks=NULL;
		static TexUnitPair _texunit_pairs[]={
			{"source_diffuse",0},
			{"source_sss",1},
			{"source_depth",2},
		};

		static UBOPair *_ubo_pairs=NULL;
		static const char _vertex_code[]={
10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,52,41,32,105,110,32,118,101,99,50,32,117,118,95,105,110,59,10,10,111,117,116,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,117,118,95,105,110,116,101,114,112,32,61,32,117,118,95,105,110,59,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,125,10,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,102,102,32,42,47,10,		0};

		static const int _vertex_code_start=2;
		static const char _fragment_code[]={
10,47,47,35,100,101,102,105,110,101,32,81,85,65,76,73,70,73,69,82,32,117,110,105,102,111,114,109,32,47,47,32,115,111,109,101,32,103,117,121,32,111,110,32,116,104,101,32,105,110,116,101,114,119,101,98,32,115,97,121,115,32,105,116,32,109,97,121,32,98,101,32,102,97,115,116,101,114,32,119,105,116,104,32,116,104,105,115,10,35,100,101,102,105,110,101,32,81,85,65,76,73,70,73,69,82,32,99,111,110,115,116,10,10,35,105,102,100,101,102,32,85,83,69,95,50,53,95,83,65,77,80,76,69,83,10,99,111,110,115,116,32,105,110,116,32,107,101,114,110,101,108,95,115,105,122,101,32,61,32,50,53,59,10,47,42,32,99,108,97,110,103,45,102,111,114,109,97,116,32,111,110,32,42,47,10,81,85,65,76,73,70,73,69,82,32,118,101,99,50,32,107,101,114,110,101,108,91,50,53,93,32,61,32,118,101,99,50,91,93,40,10,9,9,118,101,99,50,40,48,46,53,51,48,54,48,53,44,32,48,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,48,48,57,55,51,55,57,52,44,32,45,51,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,48,51,51,51,56,48,52,44,32,45,50,46,53,50,48,56,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,53,48,48,51,54,52,44,32,45,50,46,48,56,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,55,48,48,57,55,54,44,32,45,49,46,54,56,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,48,57,52,51,56,57,44,32,45,49,46,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,49,50,56,52,57,54,44,32,45,49,46,48,50,48,56,51,41,44,10,9,9,118,101,99,50,40,48,46,48,49,55,57,50,52,44,32,45,48,46,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,50,54,51,54,52,50,44,32,45,48,46,53,50,48,56,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,52,49,48,49,55,50,44,32,45,48,46,51,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,52,57,51,53,56,56,44,32,45,48,46,49,56,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,52,48,50,55,56,52,44,32,45,48,46,48,56,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,50,49,49,52,49,50,44,32,45,48,46,48,50,48,56,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,50,49,49,52,49,50,44,32,48,46,48,50,48,56,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,52,48,50,55,56,52,44,32,48,46,48,56,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,52,57,51,53,56,56,44,32,48,46,49,56,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,52,49,48,49,55,50,44,32,48,46,51,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,50,54,51,54,52,50,44,32,48,46,53,50,48,56,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,49,55,57,50,52,44,32,48,46,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,49,50,56,52,57,54,44,32,49,46,48,50,48,56,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,57,52,51,56,57,44,32,49,46,51,51,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,55,48,48,57,55,54,44,32,49,46,54,56,55,53,41,44,10,9,9,118,101,99,50,40,48,46,48,48,53,48,48,51,54,52,44,32,50,46,48,56,51,51,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,51,51,51,56,48,52,44,32,50,46,53,50,48,56,51,41,44,10,9,9,118,101,99,50,40,48,46,48,48,48,57,55,51,55,57,52,44,32,51,46,48,41,41,59,10,35,101,110,100,105,102,32,47,47,85,83,69,95,50,53,95,83,65,77,80,76,69,83,10,10,35,105,102,100,101,102,32,85,83,69,95,49,55,95,83,65,77,80,76,69,83,10,99,111,110,115,116,32,105,110,116,32,107,101,114,110,101,108,95,115,105,122,101,32,61,32,49,55,59,10,81,85,65,76,73,70,73,69,82,32,118,101,99,50,32,107,101,114,110,101,108,91,49,55,93,32,61,32,118,101,99,50,91,93,40,10,9,9,118,101,99,50,40,48,46,53,51,54,51,52,51,44,32,48,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,48,51,49,55,51,57,52,44,32,45,50,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,49,48,48,51,56,54,44,32,45,49,46,53,51,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,49,52,52,54,48,57,44,32,45,49,46,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,50,49,54,51,48,49,44,32,45,48,46,55,56,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,51,52,55,51,49,55,44,32,45,48,46,53,41,44,10,9,9,118,101,99,50,40,48,46,48,53,55,49,48,53,54,44,32,45,48,46,50,56,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,53,56,50,52,49,54,44,32,45,48,46,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,51,50,52,52,54,50,44,32,45,48,46,48,51,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,51,50,52,52,54,50,44,32,48,46,48,51,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,53,56,50,52,49,54,44,32,48,46,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,53,55,49,48,53,54,44,32,48,46,50,56,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,51,52,55,51,49,55,44,32,48,46,53,41,44,10,9,9,118,101,99,50,40,48,46,48,50,49,54,51,48,49,44,32,48,46,55,56,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,49,52,52,54,48,57,44,32,49,46,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,49,48,48,51,56,54,44,32,49,46,53,51,49,50,53,41,44,10,9,9,118,101,99,50,40,48,46,48,48,51,49,55,51,57,52,44,32,50,46,48,41,41,59,10,35,101,110,100,105,102,32,47,47,85,83,69,95,49,55,95,83,65,77,80,76,69,83,10,10,35,105,102,100,101,102,32,85,83,69,95,49,49,95,83,65,77,80,76,69,83,10,99,111,110,115,116,32,105,110,116,32,107,101,114,110,101,108,95,115,105,122,101,32,61,32,49,49,59,10,81,85,65,76,73,70,73,69,82,32,118,101,99,50,32,107,101,114,110,101,108,91,49,49,93,32,61,32,118,101,99,50,91,93,40,10,9,9,118,101,99,50,40,48,46,53,54,48,52,55,57,44,32,48,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,48,52,55,49,54,57,49,44,32,45,50,46,48,41,44,10,9,9,118,101,99,50,40,48,46,48,49,57,50,56,51,49,44,32,45,49,46,50,56,41,44,10,9,9,118,101,99,50,40,48,46,48,51,54,51,57,44,32,45,48,46,55,50,41,44,10,9,9,118,101,99,50,40,48,46,48,56,50,49,57,48,52,44,32,45,48,46,51,50,41,44,10,9,9,118,101,99,50,40,48,46,48,55,55,49,56,48,50,44,32,45,48,46,48,56,41,44,10,9,9,118,101,99,50,40,48,46,48,55,55,49,56,48,50,44,32,48,46,48,56,41,44,10,9,9,118,101,99,50,40,48,46,48,56,50,49,57,48,52,44,32,48,46,51,50,41,44,10,9,9,118,101,99,50,40,48,46,48,51,54,51,57,44,32,48,46,55,50,41,44,10,9,9,118,101,99,50,40,48,46,48,49,57,50,56,51,49,44,32,49,46,50,56,41,44,10,9,9,118,101,99,50,40,48,46,48,48,52,55,49,54,57,49,44,32,50,46,48,41,41,59,10,35,101,110,100,105,102,32,47,47,85,83,69,95,49,49,95,83,65,77,80,76,69,83,10,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,109,97,120,95,114,97,100,105,117,115,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,102,97,114,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,99,97,109,101,114,97,95,122,95,110,101,97,114,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,117,110,105,116,95,115,105,122,101,59,10,117,110,105,102,111,114,109,32,118,101,99,50,32,100,105,114,59,10,105,110,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,100,105,102,102,117,115,101,59,32,47,47,116,101,120,117,110,105,116,58,48,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,115,115,115,59,32,47,47,116,101,120,117,110,105,116,58,49,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,100,101,112,116,104,59,32,47,47,116,101,120,117,110,105,116,58,50,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,111,117,116,32,118,101,99,52,32,102,114,97,103,95,99,111,108,111,114,59,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,102,108,111,97,116,32,115,116,114,101,110,103,116,104,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,115,115,115,44,32,117,118,95,105,110,116,101,114,112,41,46,114,59,10,9,115,116,114,101,110,103,116,104,32,42,61,32,115,116,114,101,110,103,116,104,59,32,47,47,115,116,111,114,101,100,32,97,115,32,115,113,114,116,10,10,9,47,47,32,70,101,116,99,104,32,99,111,108,111,114,32,111,102,32,99,117,114,114,101,110,116,32,112,105,120,101,108,58,10,9,118,101,99,52,32,98,97,115,101,95,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,100,105,102,102,117,115,101,44,32,117,118,95,105,110,116,101,114,112,41,59,10,10,9,105,102,32,40,115,116,114,101,110,103,116,104,32,62,32,48,46,48,41,32,123,10,10,9,9,47,47,32,70,101,116,99,104,32,108,105,110,101,97,114,32,100,101,112,116,104,32,111,102,32,99,117,114,114,101,110,116,32,112,105,120,101,108,58,10,9,9,102,108,111,97,116,32,100,101,112,116,104,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,117,118,95,105,110,116,101,114,112,41,46,114,32,42,32,50,46,48,32,45,32,49,46,48,59,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,9,100,101,112,116,104,32,61,32,40,40,100,101,112,116,104,32,43,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,47,32,50,46,48,59,10,9,9,102,108,111,97,116,32,115,99,97,108,101,32,61,32,117,110,105,116,95,115,105,122,101,59,32,47,47,114,101,109,101,109,98,101,114,32,100,101,112,116,104,32,105,115,32,110,101,103,97,116,105,118,101,32,98,121,32,100,101,102,97,117,108,116,32,105,110,32,79,112,101,110,71,76,10,35,101,108,115,101,10,9,9,100,101,112,116,104,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,100,101,112,116,104,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,9,9,102,108,111,97,116,32,115,99,97,108,101,32,61,32,117,110,105,116,95,115,105,122,101,32,47,32,100,101,112,116,104,59,32,47,47,114,101,109,101,109,98,101,114,32,100,101,112,116,104,32,105,115,32,110,101,103,97,116,105,118,101,32,98,121,32,100,101,102,97,117,108,116,32,105,110,32,79,112,101,110,71,76,10,35,101,110,100,105,102,10,10,9,9,47,47,32,67,97,108,99,117,108,97,116,101,32,116,104,101,32,102,105,110,97,108,32,115,116,101,112,32,116,111,32,102,101,116,99,104,32,116,104,101,32,115,117,114,114,111,117,110,100,105,110,103,32,112,105,120,101,108,115,58,10,9,9,118,101,99,50,32,115,116,101,112,32,61,32,109,97,120,95,114,97,100,105,117,115,32,42,32,115,99,97,108,101,32,42,32,100,105,114,59,10,9,9,115,116,101,112,32,42,61,32,115,116,114,101,110,103,116,104,59,32,47,47,32,77,111,100,117,108,97,116,101,32,105,116,32,117,115,105,110,103,32,116,104,101,32,97,108,112,104,97,32,99,104,97,110,110,101,108,46,10,9,9,115,116,101,112,32,42,61,32,49,46,48,32,47,32,51,46,48,59,32,47,47,32,68,105,118,105,100,101,32,98,121,32,51,32,97,115,32,116,104,101,32,107,101,114,110,101,108,115,32,114,97,110,103,101,32,102,114,111,109,32,45,51,32,116,111,32,51,46,10,10,9,9,47,47,32,65,99,99,117,109,117,108,97,116,101,32,116,104,101,32,99,101,110,116,101,114,32,115,97,109,112,108,101,58,10,9,9,118,101,99,51,32,99,111,108,111,114,95,97,99,99,117,109,32,61,32,98,97,115,101,95,99,111,108,111,114,46,114,103,98,59,10,9,9,99,111,108,111,114,95,97,99,99,117,109,32,42,61,32,107,101,114,110,101,108,91,48,93,46,120,59,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,83,84,82,69,78,71,84,72,95,87,69,73,71,72,84,73,78,71,10,9,9,102,108,111,97,116,32,99,111,108,111,114,95,119,101,105,103,104,116,32,61,32,107,101,114,110,101,108,91,48,93,46,120,59,10,35,101,110,100,105,102,10,10,9,9,47,47,32,65,99,99,117,109,117,108,97,116,101,32,116,104,101,32,111,116,104,101,114,32,115,97,109,112,108,101,115,58,10,9,9,102,111,114,32,40,105,110,116,32,105,32,61,32,49,59,32,105,32,60,32,107,101,114,110,101,108,95,115,105,122,101,59,32,105,43,43,41,32,123,10,9,9,9,47,47,32,70,101,116,99,104,32,99,111,108,111,114,32,97,110,100,32,100,101,112,116,104,32,102,111,114,32,99,117,114,114,101,110,116,32,115,97,109,112,108,101,58,10,9,9,9,118,101,99,50,32,111,102,102,115,101,116,32,61,32,117,118,95,105,110,116,101,114,112,32,43,32,107,101,114,110,101,108,91,105,93,46,121,32,42,32,115,116,101,112,59,10,9,9,9,118,101,99,51,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,100,105,102,102,117,115,101,44,32,111,102,102,115,101,116,41,46,114,103,98,59,10,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,70,79,76,76,79,87,95,83,85,82,70,65,67,69,10,9,9,9,47,47,32,73,102,32,116,104,101,32,100,105,102,102,101,114,101,110,99,101,32,105,110,32,100,101,112,116,104,32,105,115,32,104,117,103,101,44,32,119,101,32,108,101,114,112,32,99,111,108,111,114,32,98,97,99,107,32,116,111,32,34,99,111,108,111,114,77,34,58,10,9,9,9,102,108,111,97,116,32,100,101,112,116,104,95,99,109,112,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,100,101,112,116,104,44,32,111,102,102,115,101,116,41,46,114,32,42,32,50,46,48,32,45,32,49,46,48,59,10,10,35,105,102,100,101,102,32,85,83,69,95,79,82,84,72,79,71,79,78,65,76,95,80,82,79,74,69,67,84,73,79,78,10,9,9,9,100,101,112,116,104,95,99,109,112,32,61,32,40,40,100,101,112,116,104,95,99,109,112,32,43,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,32,47,32,50,46,48,59,10,35,101,108,115,101,10,9,9,9,100,101,112,116,104,95,99,109,112,32,61,32,50,46,48,32,42,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,42,32,99,97,109,101,114,97,95,122,95,102,97,114,32,47,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,43,32,99,97,109,101,114,97,95,122,95,110,101,97,114,32,45,32,100,101,112,116,104,95,99,109,112,32,42,32,40,99,97,109,101,114,97,95,122,95,102,97,114,32,45,32,99,97,109,101,114,97,95,122,95,110,101,97,114,41,41,59,10,35,101,110,100,105,102,10,10,9,9,9,102,108,111,97,116,32,115,32,61,32,99,108,97,109,112,40,51,48,48,46,48,102,32,42,32,115,99,97,108,101,32,42,32,109,97,120,95,114,97,100,105,117,115,32,42,32,97,98,115,40,100,101,112,116,104,32,45,32,100,101,112,116,104,95,99,109,112,41,44,32,48,46,48,44,32,49,46,48,41,59,10,9,9,9,99,111,108,111,114,32,61,32,109,105,120,40,99,111,108,111,114,44,32,98,97,115,101,95,99,111,108,111,114,46,114,103,98,44,32,115,41,59,10,35,101,110,100,105,102,10,10,9,9,9,47,47,32,65,99,99,117,109,117,108,97,116,101,58,10,9,9,9,99,111,108,111,114,32,42,61,32,107,101,114,110,101,108,91,105,93,46,120,59,10,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,83,84,82,69,78,71,84,72,95,87,69,73,71,72,84,73,78,71,10,9,9,9,102,108,111,97,116,32,99,111,108,111,114,95,115,32,61,32,116,101,120,116,117,114,101,40,115,111,117,114,99,101,95,115,115,115,44,32,111,102,102,115,101,116,41,46,114,59,10,9,9,9,99,111,108,111,114,95,119,101,105,103,104,116,32,43,61,32,99,111,108,111,114,95,115,32,42,32,107,101,114,110,101,108,91,105,93,46,120,59,10,9,9,9,99,111,108,111,114,32,42,61,32,99,111,108,111,114,95,115,59,10,35,101,110,100,105,102,10,9,9,9,99,111,108,111,114,95,97,99,99,117,109,32,43,61,32,99,111,108,111,114,59,10,9,9,125,10,10,35,105,102,100,101,102,32,69,78,65,66,76,69,95,83,84,82,69,78,71,84,72,95,87,69,73,71,72,84,73,78,71,10,9,9,99,111,108,111,114,95,97,99,99,117,109,32,47,61,32,99,111,108,111,114,95,119,101,105,103,104,116,59,10,35,101,110,100,105,102,10,9,9,102,114,97,103,95,99,111,108,111,114,32,61,32,118,101,99,52,40,99,111,108,111,114,95,97,99,99,117,109,44,32,98,97,115,101,95,99,111,108,111,114,46,97,41,59,32,47,47,107,101,101,112,32,97,108,112,104,97,32,40,117,115,101,100,32,102,111,114,32,83,83,65,79,41,10,9,125,32,101,108,115,101,32,123,10,9,9,102,114,97,103,95,99,111,108,111,114,32,61,32,98,97,115,101,95,99,111,108,111,114,59,10,9,125,10,125,10,		0};

		static const int _fragment_code_start=17;
		setup(_conditional_strings,6,_uniform_strings,5,_attribute_pairs,0, _texunit_pairs,3,_ubo_pairs,0,_feedbacks,0,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	}

};

#endif

